// Daa.cpp : Defines the class behaviors for the application.
//

#include <afxadv.h> //Has CRecentFileList class definition
#include "stdafx.h"
#include "MainFrm.h"
#include "DaaDoc.h"
#include "DaaView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "dos.h"
#include "mmreg.h"

#include "Daa.h"
#include "FHT.h"


/////////////////////////////////////////////////////////////////////////////
// CDaaApp

BEGIN_MESSAGE_MAP(CDaaApp, CWinApp)
	//{{AFX_MSG_MAP(CDaaApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	
	// ----------------------------------------------------------- overrided
	//ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	ON_COMMAND(ID_FILE_OPEN, DaaFileOpen)
	ON_COMMAND_RANGE(ID_FILE_MRU_FILE1, ID_FILE_MRU_FILE4, DaaMRUFileOpen)
	// ---------------------------------------------------------------------
	
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()



/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  DaaFileOpen and DaaMRUFileOpen overrided to reopen also the last opened file 
//
//  http://support.microsoft.com/default.aspx?scid=kb;en-us;139828
//  http://support.microsoft.com/kb/243751/en-us
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool CDaaApp::DaaFileOpen()
{
   // ---------------------------------------- prompt the user
   CString newName;
   if (DoPromptFileName(newName, AFX_IDS_OPENFILE, OFN_HIDEREADONLY | OFN_FILEMUSTEXIST, TRUE, NULL))
   {
		// ----------------------------------- Get pTemplate, a pointer to one of the app's document templates
		POSITION template_pos = AfxGetApp()->GetFirstDocTemplatePosition();
		if (NULL!=template_pos) 
		{
			CDocTemplate* pDocTemplate = AfxGetApp()->GetNextDocTemplate(template_pos);
			pDocTemplate->OpenDocumentFile(newName);
		}
	   return true;
   }
   else
   {
	   return false;
   }
}


void CDaaApp::DaaMRUFileOpen(UINT i)
{
    CString strName, strCurDir, strMessage;
    int nIndex = i - ID_FILE_MRU_FILE1;
    if ((*m_pRecentFileList)[nIndex].GetLength() != 0)
	{
		strName = (LPCTSTR)(*m_pRecentFileList)[nIndex];

		// ---------------------- Get pTemplate, a pointer to one of the app's document templates
		POSITION template_pos = AfxGetApp()->GetFirstDocTemplatePosition();
		if (NULL!=template_pos) 
		{
			CDocTemplate* pDocTemplate = AfxGetApp()->GetNextDocTemplate(template_pos);
			if (pDocTemplate->OpenDocumentFile(strName) == NULL)
			{
				m_pRecentFileList->Remove(nIndex);
			}
		}
	}
}




/////////////////////////////////////////////////////////////////////////////
// CDaaApp construction

CDaaApp::CDaaApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


/////////////////////////////////////////////////////////////////////////////
// The one and only CDaaApp object

CDaaApp theApp;

CBrush sfondo (RGB (160, 160, 160));


// DAA
// ========================================================================
int helpindex, oldhelpindex;
CDC MemDC;
CBitmap MemBmp;
//BOOL dcCreated;

CFrame daaFrame, frame1, frame2, frame3, frame4, frame5, frame6;
CDisplay display;
CDialer dialer, dialer1, dialer2, dialer3;
CDialer dialer4, dialer5, dialer6, dialer7;
CDialer dialer8, dialer9, dialer10;
CDialer dialer11, dialer12, dialer13, dialerTrig;
CKey key1, key2, key3, keysamp, keycal;
CKeyboard kbWtype, kbAtype, kbRtype, kbRtype2;
CKeyboard kbTrig, kbChan, kbChtrig;
CKeyboard kbGnd1, kbGnd2, kbCurs;
CKeyboard kbInOnOff, kbOutOnOff;
CKeyboard kbTime, kbVolt;
CKeyboard kbXlog, kbYlog;
CPalette palette;
CLed ledtrig, ledcal;
CIndicator indicator;

int control, lastControl;
// ========================================================================


int polarity1 = 1;
int polarity2 = 1;



/////////////////////////////////////////////////////////////////////////////
// CDaaApp INIT INSTANCE
/////////////////////////////////////////////////////////////////////////////

BOOL CDaaApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;

	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CDaaDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CDaaView));
	AddDocTemplate(pDocTemplate);


	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

    
    /*
    // DAA specific
    if (m_lpCmdLine[0] == '\0')
    {
        cmdInfo.m_strFileName = "Base.dar";
        cmdInfo.m_nShellCommand = CCommandLineInfo::FileOpen;
        //OpenDocumentFile("Sweep.dar");
    }
    */

	DAA_Init();
	

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CDaaApp EXIT INSTANCE
/////////////////////////////////////////////////////////////////////////////

BOOL CDaaApp::ExitInstance()
{
	DAA_End();
	return CWinApp::ExitInstance();
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
/////////////////////////////////////////////////////////////////////////////

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CDaaApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CDaaApp commands



////////////////////////////////////////////////////////////////
//  READ WRITE INI
////////////////////////////////////////////////////////////////

void WriteIni()
{
    CString s;
    s.Format("%i", calY1);
    theApp.WriteProfileString("Calibrations", "CH1", s);
    s.Format("%i", calY2);
    theApp.WriteProfileString("Calibrations", "CH2", s);
}

void ReadIni()
{   
    CString s;
    s = theApp.GetProfileString("Calibrations", "CH1", "0");
    calY1 = atoi(s);
    if (calY1 > 32000 || calY1 < -32000) calY1 = 0;
    s = theApp.GetProfileString("Calibrations", "CH2", "0");
    calY2 = atoi(s);
    if (calY2 > 32000 || calY2 < -32000) calY2 = 0;
}


////////////////////////////////////////////////////////////////
// Time procedures
////////////////////////////////////////////////////////////////
static LARGE_INTEGER pfreq, ptime1, ptime2;

inline void InitTime()
{
    QueryPerformanceFrequency(&pfreq);
    pfreq.QuadPart /= 1000000;  // Time in microseconds
    QueryPerformanceCounter(&ptime1);
}

inline int GetTime()
{
    QueryPerformanceCounter(&ptime2);
    return (int)((ptime2.QuadPart - ptime1.QuadPart) / pfreq.QuadPart);
}

inline void MessageTime()
{
    int t = GetTime() - 15;  // 15 usec overhead
    CString s;
    s.Format("%i", t);
    theApp.m_pMainWnd->MessageBox(s, "", MB_SYSTEMMODAL);
}




////////////////////////////////////////////////////////////////
// Print procedures
////////////////////////////////////////////////////////////////
void Print(CDC* pDC, int x, int y, int v)
{
    CString str;
    str.Format(" %i  ", v);
    pDC->TextOut(x, y, str);
}
void Print(CDC* pDC, int x, int y, float v)
{
    CString str;
    str.Format(" %f  ", v);
    pDC->TextOut(x, y, str);
}
void Print(CDC* pDC, int x, int y, double v)
{
    CString str;
    str.Format(" % 10.3f  ", v);
    pDC->TextOut(x, y, str);
}
void Print(CDC* pDC, int x, int y, CString str)
{
    pDC->TextOut(x, y, str);
}





////////////////////////////////////////////////////////////////
// DC procedures
////////////////////////////////////////////////////////////////

/*
CRect GetWrect(CDC* pDC)
{
    CWnd* pWnd = pDC->GetWindow();
    RECT rect;
    pWnd->GetWindowRect(&rect);
    return rect;
}
*/

CRect GetCrect(CDC* pDC)
{
    CWnd* pWnd = pDC->GetWindow();
    RECT rect;
    pWnd->GetClientRect(&rect);
    return rect;
}


/////////////////////////////////////////////////////////////////////////
// SWEEP
/////////////////////////////////////////////////////////////////////////
	
void ResetSweep(BOOL resetAll)
{
    if (analisistype != ANTYPE_SWEEP) return;

    // IN
    cbufPos = 0;
    vmax = -100000;
    vmin = 100000;
    sweepLimit = 0;  
    sweepPos = -200;

    // OUT
    sweepFreq14 = int(freqmin * (1 << WTAB_SHIFT));
    sweepSample = 0;
    phase = 0;

    sweepStatus = 1;
    if (resetAll) sweepStatus = 2;      
}



/////////////////////////////////////////////////////////////////////////
// FILL BUFFER
/////////////////////////////////////////////////////////////////////////
void FillBuffer()
{
    WAVEHDR* pwh;
    __int16* pbuf;
    int i;

    nbufOut++;
    if (nbufOut >= N_BUFOUT) nbufOut = 0;
   
    pwh = &pwhOut[nbufOut];
    pbuf = pbufOut[nbufOut];
                              
    // ===================================================== PULSE
    if (analisistype == ANTYPE_PULSE)
    {    

		int pulse = int(32767 * exp(outlevel / kdb));

		for	(i = 0; i < OUT_BUF_LEN; i++)
		{
			if (pulse_position >= PULSE_TOTAL_SAMPLES) 
			{
				pulse_position = 0;
				pulseFlag = true;
			}
			//
			if (pulse_position == 0)
			{
				// Primo campione corretto per evitare esaltazione degli acuti (10..20 KHz)
				pbuf[i] = __int16(pulse * 0.09);
			}
			else if (pulse_position < PULSE_SAMPLES)
			{
				pbuf[i] = __int16((pulse * (PULSE_SAMPLES - pulse_position)) / PULSE_SAMPLES);
			}
			else
			{
				pbuf[i] = 0;
			}
			//
			pulse_position++;
		}	
    }



    // ===================================================== FAST SWEEP
    else if (analisistype == ANTYPE_FASTSW)
    {	
		int pulse = int(0.3 * 32767 * exp(outlevel / kdb));
		double k = 2600 * PI / 2.0;   

		for	(i = 0; i < OUT_BUF_LEN; i++)
		{
			if (pulse_position >= PULSE_TOTAL_SAMPLES) 
			{
				pulse_position = 0;
				pulseFlag = true;
			}
			//
			if (pulse_position < FASTSWEEP_SAMPLES)
			{
				//double ii = 1 - (pulse_position * 1.0 / FASTSWEEP_SAMPLES);
				double ii = (pulse_position * 1.0 / FASTSWEEP_SAMPLES);
				ii = pow(ii, 15); 
				pbuf[i] = __int16(pulse * sin(ii * k));
			}
			else
			{
				pbuf[i] = 0;
			}
			//
			pulse_position++;
		}	
    }



    // ===================================================== SWEEP
    else if (analisistype == ANTYPE_SWEEP)
    {
        if (xlogtype)
        {
            int nsamples = int(sweeptime * SAMPLES_PER_SEC);
            
            int sweepMax14 = int(freqmax * (1 << WTAB_SHIFT));
     
            int pmax = WTAB_LEN << WTAB_SHIFT;

            double k = log(freqmax / freqmin) / nsamples;

            int fmin14 = int(freqmin * (1 << WTAB_SHIFT));

            for	(i = 0; i < OUT_BUF_LEN; i++)
	        {
                pbuf[i] = wtab[phase >> WTAB_SHIFT];

                sweepFreq14 = int( fmin14 * exp(k * sweepSample) );
                         
                phase += sweepFreq14;
                sweepSample++;
                
                if (phase >= pmax)
                {
                    phase -= pmax;
                    
                    // Qui' inizia un nuovo ciclo
                    if (sweepFreq14 > sweepMax14)
                    {
                        sweepStatus = 1;
                        break;
                    }

                }
        
	        }

        }
        else
        {   
            int nsamples = int(sweeptime * SAMPLES_PER_SEC);

            int sweepMax14 = int(freqmax * (1 << WTAB_SHIFT));
     
            int df = int((freqmax - freqmin) * (1 << WTAB_SHIFT) / nsamples);

            int pmax = WTAB_LEN << WTAB_SHIFT;

            for	(i = 0; i < OUT_BUF_LEN; i++)
	        {
                pbuf[i] = wtab[phase >> WTAB_SHIFT];
                phase += sweepFreq14;
                sweepFreq14 += df;
    
                if (phase >= pmax)
                {
                    phase -= pmax;
                    // Qui' inizia un nuovo ciclo
                    if (sweepFreq14 >= sweepMax14)
                    {
                        sweepStatus = 1;
                        break;
                    }

                }
        
	        }

        }

        for	(i = i; i < OUT_BUF_LEN; i++)
	    {
            pbuf[i] = 0;    
        }

    }

    // ===================================================== NOISE
    else if (wavetype == WAVETYPE_NOISE)
    {
        int volt14 = int((1 << 14) * exp(outlevel / kdb));
        if (random == 0) random = 1;
        for	(i = 0; i < OUT_BUF_LEN; i++)
	    {  
			// ------------------------------------------ ( original 1999 random )
            if (random & 0x800000) random = (random << 1) ^ 0x1D872B41;
			else random = (random << 1);
			// ------------------------------------------ alternative method
			//random = 1664525L * random + 1013904223L;
			// ----------------------------------------------------------------------------------

			// ------------- ensure that random2 float value is not too great ( sound stops )
			if (fabs(random2) > 1e9) random2 = 0;
			else random2 += (random * .0002);
			// ----------------------------------------------------------------------------------
            
			// -------------------------------------------- set the value
            pbuf[i] = __int16(random2);
            pbuf[i] = __int16((pbuf[i] * volt14) >> 14);
			// ---------------------------------------------------------------------------------
        }
    }
    else
    {
        int f = int(oldfreq * (1 << WTAB_SHIFT));
        int df = int((freq - oldfreq) * (1 << WTAB_SHIFT) / OUT_BUF_LEN);
        oldfreq = freq;
        int pmax = WTAB_LEN << WTAB_SHIFT;

        switch (analisistype)
        {
            case ANTYPE_WAVE:	
            case ANTYPE_SPECTR: 
                
                for	(i = 0; i < OUT_BUF_LEN; i++)
	            {
                    pbuf[i] = wtab[phase >> WTAB_SHIFT];
                    phase += f;
                    f += df;
            
                    if (phase >= pmax)
                    {
                        phase -= pmax;
                        // Qui' inizia un nuovo ciclo
                        // e si possono effettuare gli aggiornamenti
                    }
	            }
				break;

            case ANTYPE_BURST: 
                for	(i = 0; i < OUT_BUF_LEN; i++)
	            {
                    if (burstflag) pbuf[i] = wtab[phase >> WTAB_SHIFT];
                    else pbuf[i] = 0;
                    phase += f;
                    f += df;
                    if (phase >= pmax)
                    {
                        phase -= pmax;
                        if (burstflag)
                        {
                            if (burstcounter >= int(burstcycles))
                            {
                                burstcounter = 0;
                                burstflag = FALSE;
                            }
                        }
                        else
                        {
                            if (burstcounter >= int(pausecycles))
                            {
                                burstcounter = 0;
                                burstflag = TRUE;
                                phase = 0;
                            }
                        }
                        burstcounter++;
                    }
                }
				break;

        }
    }


    // ----------------------------------------------------------- Send the buffer
	int result = waveOutWrite(hwOut, pwh, sizeof(WAVEHDR));
    
    if (result == MMSYSERR_NOERROR) activeOutBuffers++;
}



///////////////////////////////////////////////////////////////////////////////////////////////
// FILL WAVE TABLE   
///////////////////////////////////////////////////////////////////////////////////////////////

void DAA_FillWaveTable(int type)
{
    int i, mid;
    double k_pi;
    int kv_14;
    int k32767;
    double volt = exp(outlevel / kdb);

    switch (type)
    {
    case WAVETYPE_SINE:      // SIN
        // 145 millisec (64 ms release) per 44100 campioni
        k32767 = int (volt * 32767);
        k_pi = (PI * 2) / WTAB_LEN;
        for	(i = 0; i < WTAB_LEN; i++)
	    {
            wtab[i] = __int16((sin(i * k_pi) * k32767));
	    }
    break;
    case WAVETYPE_TRIANG:      // TRIANGLE /\/
        // 
        kv_14 = int(volt * (1 << 14));
        for	(i = 0; i < WTAB_LEN / 4; i++)
	    {
            wtab[i] = __int16((kv_14 * __int16(i * 131072.0 / WTAB_LEN)) >> 14);
	    }
        for	(i = WTAB_LEN / 4; i < WTAB_LEN * 3 / 4; i++)
	    {
            wtab[i] = __int16((kv_14 * __int16(65535 - i * 131072.0 / WTAB_LEN)) >> 14);
	    }
        for	(i = WTAB_LEN * 3 / 4; i < WTAB_LEN; i++)
	    {
            wtab[i] = __int16((kv_14 * __int16(i * 131072.0 / WTAB_LEN)) >> 14);
	    }
    break;
    case WAVETYPE_RAMPp:      // RAMP /|/
        // 
        kv_14 = int(volt * (1 << 14));
        for	(i = 0; i < WTAB_LEN; i++)
	    {
            wtab[i] = __int16((kv_14 * __int16(i * 65536.0 / WTAB_LEN)) >> 14);
	    }
    break;
    case WAVETYPE_RAMPm:      // RAMP \|\
        // 
        kv_14 = int(volt * (1 << 14));
        for	(i = 0; i < WTAB_LEN; i++)
	    {
            wtab[i] = __int16((kv_14 * __int16(65536 - i * 65536.0 / WTAB_LEN)) >> 14);
	    }
    break;
    case WAVETYPE_SQUARE:      // SQUARE ||_
        //
        k32767 = int (volt * 32767);
        mid = int(WTAB_LEN * duty / 100);
        for	(i = 0; i < mid; i++)
	    {
            wtab[i] = __int16(k32767);
	    }
        for	(i = mid; i < WTAB_LEN; i++)
	    {
            wtab[i] = __int16(-k32767);
	    }
    break; 
    }
}


/////////////////////////////////////////////////////////////////////////
// ADD BUFFER
/////////////////////////////////////////////////////////////////////////
void AddBuffer()
{
    nbufIn++;
    if (nbufIn >= N_BUFIN) nbufIn = 0;
    
	int result = waveInAddBuffer(hwIn, &pwhIn[nbufIn], sizeof(WAVEHDR));
    
    if (result == MMSYSERR_NOERROR) activeInBuffers++;
}


/////////////////////////////////////////////////////////////////////////
// CALLBACK
/////////////////////////////////////////////////////////////////////////
void CALLBACK waveOutProc(HWAVEOUT hwOut,
                          UINT uMsg,
                          DWORD dwInstance, 
                          DWORD dwParam1,
                          DWORD dwParam2)
{   
	hwOut; dwInstance; dwParam1; dwParam2;
	//
	switch(uMsg)
    {
	    case WOM_OPEN:
			break;                
	    case WOM_CLOSE:
			break;
	    case WOM_DONE:
            
			activeOutBuffers--;
			
            //if ((analisistype == ANTYPE_FASTSW) || (analisistype == ANTYPE_PULSE)) return;
            if (analisistype == ANTYPE_SWEEP)
            {
                if (sweepStatus == 0)     // 0 = sweeping
                {
                    if (outputState) FillBuffer();    
                }
            }
            else
            {
                if (outputState) FillBuffer();
            }
			

			break;
	}  
}	
  
     
void CALLBACK waveInProc(HWAVEIN hwIn,
                         UINT uMsg,
                         DWORD dwInstance, 
                         DWORD dwParam1,
                         DWORD dwParam2)
{
	hwIn; dwInstance; dwParam1; dwParam2;
	int v, v2;
	//
	switch(uMsg)
    {
	    case WIM_OPEN:
			break;                
	    case WIM_CLOSE:
			break;
	    case WIM_DATA:

			activeInBuffers--;	

            if (inputState)
            {
                if (analisistype == ANTYPE_SWEEP && activeOutBuffers <= 0 && sweepStatus) return;

				// ------------------------------------------------------- get pointer to data
                __int16* pbuf = (__int16*)(LPWAVEHDR(dwParam1)->lpData);

                  
                // SWEEP
                if (analisistype == ANTYPE_SWEEP && outputState && spectrumDisplay)
                {
                    int sweepX;
                    int samplesPerPixel_8 = int(sweeptime * SAMPLES_PER_SEC / dispx) << 8;

                    for (int i = 0; i < IN_BUF_LEN; i += numCH)
                    {
                        v = pbuf[i] * polarity1 + calY1;
						if (v > 32767) v = 32767;
                        if (v < -32768) v = -32768;
                        if (v > vmax) vmax = v;
                        if (v < vmin) vmin = v;

                        if (sweepPos++ >= sweepLimit)
                        {          
                            sweepX = (sweepPos << 8) / samplesPerPixel_8 - 1;
                            if (sweepX >= 0)
                            {
                                if (-vmin > vmax) vmax = -vmin;

                                if (calibratedResponse) vmax = int(vmax * calibrateTab[sweepX]);
                                responseTab[sweepX] = vmax;

                                vmax = -100000;
                                vmin = 100000;
                            }

                            sweepLimit += (samplesPerPixel_8 >> 8);
                        }
                    }
                          
                    AddBuffer();

                    return;
                }

        

                // MESURING CHANNEL 1
                else if (curstype == 1)
                {
                    vmax -= 100;
                    vmin += 100;

                    if (numCH == 1)
                    {
                        for (int i = 0; i < IN_BUF_LEN; i ++)
                        {
                            v = pbuf[i] * polarity1 + calY1;
							if (v > 32767) v = 32767;
                            if (v < -32768) v = -32768;
							if (v > vmax) vmax = v;
                            if (v < vmin) vmin = v;
                            pCbufIn[i + cbufPos] = __int16(v);

                            if (fmeterFlag)
                            {
                                if (v < fmeterTrigDown)
                                {
                                    fmeterFlag = FALSE;
                                    fmeterCycles ++; 
                                    if (fmeterSamples > SAMPLES_PER_SEC)
                                    {
                                        fmeterResultSamples = fmeterSamples + (i / numCH);
                                        fmeterResultCycles = fmeterCycles;
                                        fmeterSamples = -(i / numCH);
                                        fmeterCycles = 0;
                                    }
                                     
                                }
                            }
                            else if (v > fmeterTrigUp) fmeterFlag = TRUE;
                        }
                    }
                    else
                    {
                        int cbpos2 = cbufPos + 1;

                        for (int i = 0; i < IN_BUF_LEN; i += 2)
                        {
                            v = pbuf[i] * polarity1 + calY1;
							if (v > 32767) v = 32767;
                            if (v < -32768) v = -32768;
							if (v > vmax) vmax = v;
                            if (v < vmin) vmin = v;
                            pCbufIn[i + cbufPos] = __int16(v);

							v2 = pbuf[i + 1] * polarity2 + calY2;
							if (v2 > 32767) v2 = 32767;
                            if (v2 < -32768) v2 = -32768;
                            pCbufIn[i + cbpos2] = __int16(v2);
                            
                            if (fmeterFlag)
                            {
                                if (v < fmeterTrigDown)
                                {
                                    fmeterFlag = FALSE;
                                    fmeterCycles ++; 
                                    if (fmeterSamples > SAMPLES_PER_SEC)
                                    {
                                        fmeterResultSamples = fmeterSamples + (i / numCH);
                                        fmeterResultCycles = fmeterCycles;
                                        fmeterSamples = -(i / numCH);
                                        fmeterCycles = 0;
                                    }
                                     
                                }
                            }
                            else if (v > fmeterTrigUp) fmeterFlag = TRUE;
                        }
                    }
                }

                // MESURING CHANNEL 2
                else if (curstype == 2)
                {
                    vmax -= 100;
                    vmin += 100;

                    if (numCH == 1)
                    {
                        for (int i = 0; i < IN_BUF_LEN; i ++)
                        {
                            v = pbuf[i] * polarity1 + calY1;
							if (v > 32767) v = 32767;
							if (v < -32768) v = -32768;
						    if (v > vmax) vmax = v;
                            if (v < vmin) vmin = v;
                            pCbufIn[i + cbufPos] = __int16(v);

                            if (fmeterFlag)
                            {
                                if (v < fmeterTrigDown)
                                {
                                    fmeterFlag = FALSE;
                                    fmeterCycles ++; 
                                    if (fmeterSamples + i > SAMPLES_PER_SEC)
                                    {
                                        fmeterResultSamples = fmeterSamples + (i / numCH);
                                        fmeterResultCycles = fmeterCycles;
                                        fmeterSamples = -(i / numCH);
                                        fmeterCycles = 0;
                                    }
                                     
                                }
                            }
                            else if (v > fmeterTrigUp) fmeterFlag = TRUE;

                        }
                    }
                    else
                    {
                        int cbpos2 = cbufPos + 1;

                        for (int i = 0; i < IN_BUF_LEN; i += 2)
                        {
							v = pbuf[i] * polarity1 + calY1;
							if (v > 32767) v = 32767;
							if (v < -32768) v = -32768;
						    if (v > vmax) vmax = v;
                            if (v < vmin) vmin = v;
                            pCbufIn[i + cbufPos] = __int16(v);

							v2 = pbuf[i + 1] * polarity2 + calY2;
							if (v2 > 32767) v2 = 32767;
                            if (v2 < -32768) v2 = -32768;
                            pCbufIn[i + cbpos2] = __int16(v2);

                            if (fmeterFlag)
                            {
                                if (v < fmeterTrigDown)
                                {
                                    fmeterFlag = FALSE;
                                    fmeterCycles ++; 
                                    if (fmeterSamples + i > SAMPLES_PER_SEC)
                                    {
                                        fmeterResultSamples = fmeterSamples + (i / numCH);
                                        fmeterResultCycles = fmeterCycles;
                                        fmeterSamples = -(i / numCH);
                                        fmeterCycles = 0;
                                    }
                                     
                                }
                            }
                            else if (v > fmeterTrigUp) fmeterFlag = TRUE;
                        }
                    }
                }

                // FAST INPUT
                else
                {
                    if (numCH == 1)
                    {
                        for (int i = 0; i < IN_BUF_LEN; i ++)
                        {
							v = pbuf[i] * polarity1 + calY1;
							if (v > 32767) v = 32767;
							if (v < -32768) v = -32768;
                            pCbufIn[i + cbufPos] = __int16(v);
                        }
                    }
                    else
                    {
                        int cbpos2 = cbufPos + 1;

                        for (int i = 0; i < IN_BUF_LEN; i += 2)
                        {
							v = pbuf[i] * polarity1 + calY1;
							if (v > 32767) v = 32767;
							if (v < -32768) v = -32768;
                            pCbufIn[i + cbufPos] = __int16(v);

							v2 = pbuf[i + 1] * polarity2 + calY2;
							if (v2 > 32767) v2 = 32767;
                            if (v2 < -32768) v2 = -32768;
                            pCbufIn[i + cbpos2] = __int16(v2);
                        }
                    }
                }

                fmeterSamples += (IN_BUF_LEN / numCH);
                cbufPos += IN_BUF_LEN;
                if (cbufPos >= IN_CBUF_LEN) cbufPos = 0;

                AddBuffer();
            }
		
			break;
	}  
}


        


                

/*================================================================================
===== CDisplay ================================|  CLASS                           |
                                                ==================================
   Description    .                     
=================================================================================*/
void CDisplay::Draw(CDC* pDC)
{
    if (!dcCreated)
    {
        bmpGrid.CreateCompatibleBitmap(pDC, ddx, ddy);
        dcGrid.CreateCompatibleDC(pDC);
        dcGrid.SelectObject(bmpGrid);
        bmpScreen.CreateCompatibleBitmap(pDC, ddx, ddy);
        dcScreen.CreateCompatibleDC(pDC);
        dcScreen.SelectObject(bmpScreen);
        dcCreated = TRUE;
    }

    if (dcCreated) CreateGrid();

    CPen pen(PS_SOLID, 2, grey5);
    CBrush brush(grey3);
    CPen pen2(PS_SOLID, 2, grey8);
    CBrush brush2(grey6);
    CPen pen3(PS_SOLID, 2, grey6);
    CBrush brush3(grey6);
    CPen pen4(PS_SOLID, 2, black);
    CBrush brush4(grey3);
    CPen pen5(PS_SOLID, 2, black);
    CBrush brush5(grey5);

    CPen* pOldPen = pDC->SelectObject(&pen);
    CBrush* pOldBrush = pDC->SelectObject(&brush); 
    // Shadow
    pDC->RoundRect(x, y, dx + ddx + b + bIn + 6, dy + ddy + b + bIn + 6, 18, 18);
    // External panel
    pDC->SelectObject(pen2);
    pDC->SelectObject(brush2);
    pDC->RoundRect(x, y, dx + ddx + b + bIn, dy + ddy + b + bIn, 12, 12);
    pDC->SelectObject(pen3);
    pDC->SelectObject(brush3);
    pDC->RoundRect(x + 2, y + 2, dx + ddx + b + bIn, dy + ddy + b + bIn, 12, 12);
    // Internal mask
    pDC->SelectObject(pen4);
    pDC->SelectObject(brush4);
    pDC->RoundRect(x + b, y + bUp, dx + ddx + bIn , dy + ddy + bIn, 12, 12);
    // Screen
    pDC->SelectObject(pen5);
    pDC->SelectObject(brush5);
    pDC->RoundRect(dx - 1, dy - 1, dx + ddx + 1, dy + ddy + 1, 1, 1);

    pDC->SelectObject(pOldPen);
    pDC->SelectObject(pOldBrush);
   
    title.Draw(pDC);
}    


void CDisplay::CreateGrid()
{
    referenceFlag = FALSE;

    CDC* pDC = &dcGrid;
    int i, step, px, py;

    CPen* pOldPen = pDC->SelectObject(&pens[0]);  
      
    if (analisistype == ANTYPE_SPECTR && spectrum3D && spectrumDisplay)
    {
        pDC->FillSolidRect(0, 0, ddx, ddy, RGB(0,0,0));
    }
    else
    {
        pDC->FillSolidRect(0, 0, ddx, ddy, dback);
    }

    dgrid= RGB(gridLight, 50 + gridLight / 3, 80);
    CPen pengrid;

    if (analisistype >= ANTYPE_SPECTR && spectrumDisplay)
    { 
        CFont font;
        font.CreateFont(12, 0, 0, 0, 100, 0, 0, 0, 0, 0, 0, CLEARTYPE_QUALITY, 0, "Arial");
        CFont* pOldFont = pDC->SelectObject(&font);
        pDC->SetBkMode (TRANSPARENT);

        int r = int(osdIntensity + 25);
        int g = int(osdIntensity + 55);
        int b = int(osdIntensity + 45);
        COLORREF osdColor = RGB(r, g, b);
        pDC->SetTextColor(osdColor);

        if (analisistype == ANTYPE_SPECTR && spectrum3D)
        {
            pengrid.CreatePen(PS_SOLID, 1, osdColor);
            pDC->SelectObject(pengrid);
        }
        else
        {
            pengrid.CreatePen(PS_SOLID, 1, dgrid);
            pDC->SelectObject(pengrid);
            pDC->MoveTo(leftborder, dispy);
            pDC->LineTo(ddx, dispy);
            pDC->MoveTo(leftborder, 0);
            pDC->LineTo(leftborder, dispy);
        }
        

        CString s;
        double min, max;
       
        // X AXIS
        double klog = (dispx - 1) / log(freqmax / freqmin);

        if (xlogtype && freqmax / freqmin >= 10)
        {
            double decmin = 100000;
            double decmax = .01;
            while (decmin > freqmin) decmin /= 10; 
            while (decmax < freqmax) decmax *= 10;
            for (double f = decmin; f <= decmax; f *= 10)
            {
                for (i = 1; i < 10; i++)
                {
                    double x = klog * log(f * i / freqmin);

                    if (x >= 0 && x <= dispx)
                    {
                        px = int(leftborder + x +.5);
                        pDC->MoveTo(px, 0);

                        if (i == 1)
                        {
                            pDC->LineTo(px, ddy - downborder + 4);
                            if (px > ddx - 18) px = ddx - 18;
                            if (analisistype == ANTYPE_SPECTR && spectrum3D)
                            {
                                if(px < leftborder + 14) px = leftborder + 14;
                            }

                            if (f == .1) pDC->TextOut(px - 8, ddy - 12, ".1 Hz");
                            else if (f == 1) pDC->TextOut(px - 4, ddy - 12, "1 Hz");
                            else if (f == 10) pDC->TextOut(px - 8, ddy - 12, "10 Hz");
                            else if (f == 100) pDC->TextOut(px - 12, ddy - 12, "100 Hz");
                            else if (f == 1000) pDC->TextOut(px - 10, ddy - 12, "1 KHz");
                            else if (f == 10000) pDC->TextOut(px - 14, ddy - 12, "10 KHz");
                        }
                        else if (i == 2)
                        {
                            pDC->LineTo(px, ddy - downborder + 4);

                            if ((freqmax / freqmin) < 200)
                            {
                                if (px > ddx - 18) px = ddx - 18;
                                if (analisistype == ANTYPE_SPECTR && spectrum3D)
                                {
                                    if(px < leftborder + 14) px = leftborder + 14;
                                }
                                if (f == .1) pDC->TextOut(px - 8, ddy - 12, ".2 Hz");
                                else if (f == 1) pDC->TextOut(px - 4, ddy - 12, "2 Hz");
                                else if (f == 10) pDC->TextOut(px - 8, ddy - 12, "20 Hz");
                                else if (f == 100) pDC->TextOut(px - 12, ddy - 12, "200 Hz");
                                else if (f == 1000) pDC->TextOut(px - 10, ddy - 12, "2 KHz");
                                else if (f == 10000) pDC->TextOut(px - 14, ddy - 12, "20 KHz");
                            }
                        }
                        else if (i == 5)
                        {
                            pDC->LineTo(px, ddy - downborder + 4);

                            if ((freqmax / freqmin) < 100)
                            {
                                if (px > ddx - 18) px = ddx - 18;
                                if (analisistype == ANTYPE_SPECTR && spectrum3D)
                                {
                                    if(px < leftborder + 12) px = leftborder + 12;
                                }
                                if (f == .1) pDC->TextOut(px - 8, ddy - 12, ".5 Hz");
                                else if (f == 1) pDC->TextOut(px - 4, ddy - 12, "5 Hz");
                                else if (f == 10) pDC->TextOut(px - 8, ddy - 12, "50 Hz");
                                else if (f == 100) pDC->TextOut(px - 12, ddy - 12, "500 Hz");
                                else if (f == 1000) pDC->TextOut(px - 10, ddy - 12, "5 KHz");
                            }
                        }
                        else
                        {
                            if (analisistype == ANTYPE_SPECTR && spectrum3D)
                            {
                                pDC->LineTo(px, ddy - downborder + 2);
                            }
                            else pDC->LineTo(px, ddy - downborder);
                        }
                    }
                }
            }
        }
        else
        {
            double deltaf = freqmax - freqmin;
            double step = .1;

            if (deltaf > 0)
            {                
                int nstep = 13;
                if (freqmax >= 10000) nstep = 10;
                if (xlogtype && freqmax / freqmin > 2 && freqmax >= 1000) nstep = 8;

                while (deltaf / step > nstep)
                {
                    step *= 2;
                    if (deltaf / step > nstep) step *= 2.5;
                    if (deltaf / step > nstep) step *= 2;
                }

                max = ceil(freqmax / step + .5) * step;
                min = floor(freqmin / step + .5) * step;
                for (double f = min; f <= max; f += step)
                {
                    if (f >= freqmin && f <= freqmax)
                    {    
                        if (xlogtype) px = leftborder + int(klog * log(f / freqmin));
                        else px = leftborder + int((dispx - 1) * (f - freqmin) / deltaf);

                        pDC->MoveTo(px, 0);
                        pDC->LineTo(px, ddy - downborder + 4);
                       
                        if (px < ddx - 10)
                        {
                            if (analisistype == ANTYPE_SPECTR && spectrum3D)
                            {
                                if(px < leftborder + 10) px = leftborder + 10;
                            }

                            if (int(f) == f) s.Format("%1.0f", f);
                            else s.Format("%1.1f", f);
                            pDC->TextOut(px - 10, ddy - 12, s);
                        }
                    }                  
                }
            }

            int nstep = 4;
            if (xlogtype) nstep = 3;
            if (deltaf / step < nstep)
            {
                s.Format("%1.1f", freqmax);
                if (freqmax >= 10000) pDC->TextOut(ddx - 36, ddy - 12, s);
                else if (freqmax >= 1000) pDC->TextOut(ddx - 28, ddy - 12, s);
                else pDC->TextOut(ddx - 24, ddy - 12, s);
            }        
        }

        if (analisistype == ANTYPE_SPECTR && spectrum3D)
        {
            dcScreen.BitBlt(0, dispy, ddx, ddy, &dcGrid, leftborder, dispy, SRCCOPY);
            
           
            pDC->FillSolidRect(0, 0, 70, 115, RGB(0,0,0));

            for (int i = 0; i < 32; i++)
            {
                pDC->SelectObject(&pens[i]);
                pDC->MoveTo(10, 114 - i * 3);
                pDC->LineTo(30, 114 - i * 3);
                pDC->MoveTo(10, 113 - i * 3);
                pDC->LineTo(30, 113 - i * 3);
                pDC->MoveTo(10, 112 - i * 3);
                pDC->LineTo(30, 112 - i * 3);
            }

            if (ylogtype)
            {
                pDC->TextOut(16, 4, "dB");
                double k = (dbmax - dbmin) / 32; 
                double db;
                for (int i = 0; i <= 32; i+= 4)
                {
                     db = dbmin + k * i;
                     s.Format("%1.1f", db);
                     pDC->TextOut(38, 106 - i * 3, s);
                }
            }
            else
            {
                double mvmin = 2 * exp(dbmin / kdb) * 1000;
                double mvmax = 2 * exp(dbmax / kdb) * 1000;
                pDC->TextOut(14, 4, "mV");
                double k = (mvmax - mvmin) / 32; 
                double mv;
                for (int i = 0; i <= 32; i+= 4)
                {
                     mv = mvmin + k * i;
                     if (mv >= 1000) s.Format("%1.0f", mv);
                     else if (mv >= 10) s.Format("%1.1f", mv);
                     else s.Format("%1.3f", mv);
                     pDC->TextOut(38, 106 - i * 3, s);
                }

            }
        }


        if (!(analisistype == ANTYPE_SPECTR && spectrum3D))
        {
            // Y AXIS       
            if (ylogtype && !(analisistype == ANTYPE_SPECTR && spectrum3D))
            {
                double deltadb = dbmax - dbmin;
                double step = .1;
                int nstep = 20;
                while (deltadb / step > nstep)
                {
                    step *= 2;
                    if (deltadb / step > nstep) step *= 2.5;
                    if (deltadb / step > nstep) step *= 2;
                }

                max = ceil(dbmax / step + .5) * step;
                min = floor(dbmin / step + .5) * step;
                for (double db = min; db <= max; db += step)
                {
                    if (db >= dbmin && db <= dbmax)
                    {
                        int y = int(dispy - (dispy * (db - dbmin) / (dbmax - dbmin)) + .5);
                        pDC->MoveTo(leftborder - 4, y);
                        pDC->LineTo(ddx, y);
                        if (y > 14)
                        {
                            if (y > dispy - 2) y = dispy - 2;
                            if (int(db) == db) s.Format("%1.0f", db);
                            else s.Format("%1.1f", db);
                            pDC->TextOut(3, y - 6, s);
                        }
                    }
                }
                pDC->TextOut(5, 0, "dB");
            }
            else
            {
                double mvmin = 2 * exp(dbmin / kdb) * 1000;
                double mvmax = 2 * exp(dbmax / kdb) * 1000;

                double deltamv = mvmax - mvmin;
                double step = .001;
                int nstep = 20;
                while (deltamv / step > nstep)
                {
                    step *= 2;
                    if (deltamv / step > nstep) step *= 2.5;
                    if (deltamv / step > nstep) step *= 2;
                }

                max = ceil(mvmax / step + .5) * step;
                min = floor(mvmin / step + .5) * step;
                for (double mv = min; mv <= max; mv += step)
                {
                    if (mv >= mvmin && mv <= mvmax)
                    {
                        int y = int(dispy - (dispy * (mv - mvmin) / (mvmax - mvmin)) + .5);
                        pDC->MoveTo(leftborder - 4, y);
                        pDC->LineTo(ddx, y);
                        if (y >= 16)
                        {
                            if (y > dispy - 2) y = dispy - 2;
                            if (int(mv) == mv) s.Format("%0.0f", mv);
                            else if (fabs(int(mv * 10 + .5) - mv * 10) < .0001) s.Format("%0.1f", mv);
                            else if (fabs(int(mv * 100 + .5) - mv * 100) < .0001) s.Format("%0.2f", mv);
                            else s.Format("%0.3f", mv);
                            pDC->TextOut(3, y - 6, s);
                        }
                    }
                }
                pDC->TextOut(4, 0, "mV");
            }
        }
        pDC->SelectObject(pOldFont);

    }
    else
    {
        pengrid.CreatePen(PS_SOLID, 1, dgrid);
        pDC->SelectObject(pengrid);

         //Grid 10 x 8  
        px = 1 << 15;
        step = (ddx << 16) / 10;
        for (i = 1; i < 10; i++)
        {
            px += step;
            pDC->MoveTo(px >> 16, 0);
            pDC->LineTo(px >> 16, ddy);
        }
        py = ddy / 2;
        px = 1 << 15;  
        step = (ddx << 16) / 50;
        for (i = 1; i < 50; i++)
        {
            px += step;
            pDC->MoveTo(px >> 16, py - 5);
            pDC->LineTo(px >> 16, py + 4);
        }

        py = -1 << 15;
        step = (ddy << 16) / 8;
        for (i = 1; i < 8; i++)
        {
            py += step;
            pDC->MoveTo(0, py >> 16);
            pDC->LineTo(ddx, py >> 16);
        }
        px = ddx / 2;
        py = -1 << 15;
        step = (ddy << 16) / 40;
        for (i = 1; i < 40; i++)
        {
            py += step;
            pDC->MoveTo(px - 3, py >> 16);
            pDC->LineTo(px + 4, py >> 16);
        }
    }
      
    pDC->SelectObject(pOldPen);
}



void CDisplay::Clear()
{
    dcScreen.FillSolidRect(0, 0, ddx, ddy, RGB(0,0,0));
}

void CDisplay::DisplayWave(CDC* pDC)
{
    if (analisistype == ANTYPE_SPECTR && spectrum3D && spectrumDisplay)
    {
        if (inputState)
        {    
            CRect rect(0, 0, ddx, dispy);
            dcScreen.ScrollDC(1, -1, &rect, &rect, NULL, NULL );
            PlotSpectrum3D(&dcScreen);
        }

        dcScreen.BitBlt(12, 8, 70, 115, &dcGrid, 0, 0, SRCCOPY);    
        pDC->BitBlt(dx, dy, ddx, ddy, &dcScreen, 0, 0, SRCCOPY);
    }
    else
    {
        //if (GetAsyncKeyState(VK_LBUTTON) & 0x8000 && analisistype == ANTYPE_SWEEP) return;

        //InitTime(); 

        // 7 mS (320 * 240 * 16 bit) 2.9 mS (320 * 240 * 8 bit)
        if (!multiDraw || analisistype != ANTYPE_SWEEP)
		{
			if (dcScreen != NULL) dcScreen.BitBlt(0, 0, ddx, ddy, &dcGrid, 0, 0, SRCCOPY);   
		}
        PlotWave(&dcScreen);



        // CURSOR
        /*
        if (pDC->GetWindow())
        {
            CPoint point;
            GetCursorPos(&point);
            pDC->GetWindow()->ScreenToClient(&point);
            point.x -= dx;
            point.y -= dy;
            HICON cursor = theApp.LoadStandardCursor(IDC_ARROW);
            //HCURSOR cursor = LoadCursor(NULL, IDC_ARROW);
            dcScreen.DrawIcon( point, cursor );
        }
        */

        
        pDC->BitBlt(dx, dy, ddx, ddy, &dcScreen, 0, 0, SRCCOPY);

        //Print(pDC,220,50,GetTime());
    }

	// -------------------------------------- change the speed to the knob "Delay" to follow the "TimeBase"
	dialer9.SetMultiplier(scaleX / 100);
}



//*********************************************************
//*  SPECTRUM  3D                                         *
//*********************************************************

void CDisplay::PlotSpectrum3D(CDC* pDC)
{ 

    CPen penback(PS_SOLID, 1, dback);
    
    CPen* pOldPen = pDC->SelectObject(&pens[0]);
    pDC->MoveTo(0, dispy -1);
    pDC->LineTo(dispx + 1, dispy -1);
    pDC->MoveTo(0, dispy );
    pDC->LineTo(dispx + 1, dispy );
  
    pDC->SelectObject(&penblack);
    pDC->MoveTo(0, 0);
    pDC->LineTo(0, dispy);

    
    pDC->SelectObject(&pens[1]);
    pDC->MoveTo(0, dispy);
    pDC->LineTo(0, dispy - 2);
    pDC->MoveTo(dispx, dispy);
    pDC->LineTo(dispx, dispy - 2);

                                              // InitTime();
    int px;
    int nn;
   
    double k = (freqmax - freqmin) / 20;
    if (xlogtype && freqmin < k) k = freqmin;
    if (k >= 800) nn = 1024;
    else if (k >= 200) nn = 2048;
    else if (k >= 100) nn = 4096;
    else nn = 8192;
	if (SAMPLES_PER_SEC > 50000) nn *= 2;
	if (SAMPLES_PER_SEC > 150000) nn *= 2;

     
                                              // pDC->SetBkMode(OPAQUE);
                                              // pDC->SetBkColor(RGB(0,0,0));
                                              // Print (pDC, 250, dispy, nn);
   
    FHT(nn);
                                              // Print(pDC, 10, dispy, GetTime());
    int ix = 0;
    int y, oldy;
    int p, oldp = 0;
    double vv = 0;
    
    if (ylogtype)
    {
        double db;
                   
        for (px = 0; px < dispx; px ++) 
        {
            vv = responseTab[ix++];
            if (vv > -1) break;
        }
        db = kdb * log(vv / 32768.0);
        y = int((16 * (db - dbmin) / (dbmax - dbmin)) + .5);
        if (y < 0) y = 0;
        oldy = y;
        pDC->MoveTo(0, dispy - y);

        for (px; px < dispx; px ++)
        {        
            vv = responseTab[ix++];
            if (vv > -1)
            {
                db = kdb * log(vv / 32768.0);
                y = int((16 * (db - dbmin) / (dbmax - dbmin)) + .5);
                if (y < 0) y = 0;

                p = y + oldy;
                oldy = y;

                if (p > 31) p = 31;
                if (p != oldp)
                {
                    pDC->SelectObject(&pens[p]);
                    oldp = p;
                }
  
                pDC->LineTo(px, dispy - y);
            }
        }
    }
    else
    {
        double kv = 2.0 / 32768;
        double vmin = 2 * exp(dbmin / kdb);
        double vmax = 2 * exp(dbmax / kdb);
        for (px = 0; px < dispx; px ++) 
        {
            vv = responseTab[ix++];
            if (vv > -1) break;
        }
        y = int((16 * (vv * kv - vmin) / (vmax - vmin)) + .5);
        if (y < 0) y = 0;
        oldy = y;
        pDC->MoveTo(0, dispy - y);

        for (px; px < dispx; px ++)
        {        
            vv = responseTab[ix++];
            if (vv > -1)
            {
                y = int((16 * (vv * kv - vmin) / (vmax - vmin)) + .5);
                if (y < 0) y = 0;

                p = y + oldy;
                oldy = y;

                if (p > 31) p = 31;
                if (p != oldp)
                {
                    pDC->SelectObject(&pens[p]);
                    oldp = p;
                }

                pDC->LineTo(px, dispy - y);
            }
        }
    }
    pDC->SelectObject(pOldPen);
}





//*********************************************************
//*  PLOT WAVES SPECTRUM & PULSE                          *
//*********************************************************

void CDisplay::PlotSweepWave(CDC* pDC)
{
    int ix = 0;
    int y;

    if (ylogtype)
    {
        double db;       
        double v = responseTab[ix++];
        db = kdb * log(v / 32768.0);
        y = int((dispy * (db - dbmin) / (dbmax - dbmin)) + .5);
        //if (y < -1) y = -1;
        pDC->MoveTo(leftborder, dispy - y);

        for (int px = leftborder; px < ddx; px ++)
        {        
            v = responseTab[ix++];         
            if (v)
            {
                db = kdb * log(v / 32768.0);
                y = int((dispy * (db - dbmin) / (dbmax - dbmin)) + .5);
                //if (y < -1) y = -1;
                pDC->LineTo(px, dispy - y);
            }
        }
    }
    else
    {
        double kv = 2.0 / 32768;
        double vmin = 2 * exp(dbmin / kdb);
        double vmax = 2 * exp(dbmax / kdb);
        double v = responseTab[ix];
        y = int((dispy * (v * kv - vmin) / (vmax - vmin)) + .5);
        pDC->MoveTo(leftborder, dispy - y);

        for (int px = leftborder; px < ddx; px ++)
        {        
            v = responseTab[ix++];
            if (v)
            {
                y = int((dispy * (v * kv - vmin) / (vmax - vmin)) + .5);
                pDC->LineTo(px, dispy - y);
            }
        }
    }
}


void CDisplay::PlotWave(CDC* pDC)
{ 
	if (pDC->m_hDC == 0) return;

    int r = int(traceIntensity);
    int g = int(traceIntensity + 15);
    int b = int(traceIntensity + 20);
    if (g > 255) g = 255;
    if (b > 255) b = 255;
    trace = RGB(r, g, b);
    CPen pentrace(PS_SOLID, 1, trace);

    r = int(osdIntensity + 25);
    g = int(osdIntensity + 55);
    b = int(osdIntensity + 45);
    //if (g > 255) g = 255;
    //if (b > 255) b = 255;
    COLORREF osdColor = RGB(r, g, b);
    CPen pentrig(PS_SOLID, 1, osdColor);

    CPen* pOldPen = pDC->SelectObject(&pentrace);

         
    //InitTime();
    //Print(pDC,100,4,activeInBuffers);
    //Print(pDC,150,4,activeOutBuffers);


   	// =============================================================== calc the global "fht_samples"
	if (analisistype == ANTYPE_SPECTR)
    {
        double k = (freqmax - freqmin) / 20;
        if (xlogtype && freqmin < k) k = freqmin;
        if (k >= 800) fht_samples = 1024;
        else if (k >= 200) fht_samples = 2048;
        else if (k >= 100) fht_samples = 4096;
        else fht_samples = 8192;
		if ( SAMPLES_PER_SEC > 50000 ) fht_samples = fht_samples * 2;
		if ( SAMPLES_PER_SEC > 150000) fht_samples = fht_samples * 2;
    }
	else if (analisistype == ANTYPE_FASTSW) 
    {
		fht_samples = FASTSWEEP_FHT_SAMPLES;
    }
	else if (analisistype == ANTYPE_PULSE) 
    {
		fht_samples = PULSE_FHT_SAMPLES;
    }


    

    ///////////////////////
    // Wave from input
    ///////////////////////
    int px, py, py1, py2;
    py = ddy / 2 - 1;
    py1 = py - int(posY1 * ddy);
    py2 = py - int(posY2 * ddy);
  
    int ky1 = (ddy << 16) / int(scaleY1 / regY1 * 32.768 * 8);
    int ky2 = (ddy << 16) / int(scaleY2 / regY2 * 32.768 * 8);

    if (gnd1 == 2) ky1 = 0;
    if (gnd2 == 2) ky2 = 0;

	if (gnd1 == 0) polarity1 = 1; 
	else polarity1 = -1;
    
	if (gnd2 == 0) polarity2 = 1;
	else polarity2 = -1;


    //Print(pDC,5,4,ky);
    int step = int((ddx << 14) * 100 / scaleX * regX / SAMPLES_PER_SEC);
    //Print(pDC,200,4,double(step / double(1<<14)));
    //Print(pDC,5,4,vispos);

    int sampPerScreen = numCH * (ddx << 14) / step;

    int tglev;
    if (trigCH) tglev = -int((triglev * scaleY2 / regY2 * 32768) / ddy);
    else tglev = -int((triglev * scaleY1 / regY1 * 32768) / ddy);
   
    triggered = FALSE;

    if (inputState)
    {
        readpos = cbufPos - int(sampPerScreen * (1 - trigpos)) - 4;      
        while (readpos < 0) readpos += IN_CBUF_LEN; 


        //*********************************************************
        //*  TRIGGER                                              *
        //*********************************************************
        if (trigtype && analisistype < ANTYPE_SPECTR) 
        {
            //int samplesmax = sampPerScreen * 10;
			int samplesmax = sampPerScreen * 50;

            if (samplesmax > IN_CBUF_LEN) samplesmax = IN_CBUF_LEN;

            int ky;
            if (numCH == 2) readpos &= 0xFFFFFFFE;

            if (trigCH == 0)
            {
                ky = ky1;        
            }
            else
            {
                ky = ky2;
                readpos += 1;
            }

           
            int tgist = 0;
            if (ky) tgist = int(trigist * 20 * (1 << 16)) / ky;            
            //Print(pDC,100,4,tgist);
            px = 0;

            if (trigburst)
            {
                int v, min, max;

                //int numsamp = 2 + int(((trigstab / 10) * sampPerScreen));
				int numsamp = 2 + int((trigstab * sampPerScreen));

                //Print(pDC,100,4, numsamp);
				//Print(pDC,100,4, samplesmax);

                if (!trigslope)
                {
                    //POSITIVE BURST TRIGGER  ( burst start )
                    do
                    {
                        min = 100000;
                        max = -100000;
                        for (int i = 0; i < numsamp; i++)
                        {
                            v = pCbufIn[readpos];
                            if (v > max) max = v;
                            if (v < min) min = v;
                            readpos -= numCH;
                            if (readpos < 0) readpos += IN_CBUF_LEN;
                        }
                        px += numsamp;
                    }while (((max - min) < tgist) && (px < samplesmax));

                    do
                    {
                        min = 100000;
                        max = -100000;
                        for (int i = 0; i < numsamp; i++)
                        {
                            v = pCbufIn[readpos];
                            if (v > max) max = v;
                            if (v < min) min = v;
                            readpos -= numCH;
                            if (readpos < 0) readpos += IN_CBUF_LEN;
                        }
                        px += numsamp;
                    }while (((max - min) > tgist) && (px < samplesmax));
              
                    if (tglev < (max - min) / 2)
                    {
                        for (px = px; px < samplesmax; px++)
                        { 
                            if (pCbufIn[readpos] <= tglev) break;
                            readpos += numCH;
                            if (readpos >= IN_CBUF_LEN) readpos -= IN_CBUF_LEN;
                        }
                    }
                    else
                    {
                        for (px = px; px < samplesmax; px++)
                        { 
                            if (pCbufIn[readpos] >= tglev) break;
                            readpos += numCH;
                            if (readpos >= IN_CBUF_LEN) readpos -= IN_CBUF_LEN;
                        }
                    }

                }
                else
                {

                    //NEGATIVE BURST TRIGGER   ( burst end )
                    do
                    {
                        min = 100000;
                        max = -100000;
                        for (int i = 0; i < numsamp; i++)
                        {
                            v = pCbufIn[readpos];
                            if (v > max) max = v;
                            if (v < min) min = v;
                            readpos -= numCH;
                            if (readpos < 0) readpos += IN_CBUF_LEN;
                        }
                        px += numsamp;
                    }while (((max - min) > tgist) && (px < samplesmax));

                   
              
                    if (tglev < (max - min) / 2)
                    {
                        for (px = px; px < samplesmax; px++)
                        { 
                            if (pCbufIn[readpos] <= tglev) break;
                            readpos -= numCH;
                            if (readpos < 0) readpos += IN_CBUF_LEN;
                        }
                    }
                    else
                    {
                        for (px = px; px < samplesmax; px++)
                        { 
                            if (pCbufIn[readpos] >= tglev) break;
                            readpos -= numCH;
                            if (readpos < 0) readpos += IN_CBUF_LEN;
                        }
                    }
                }

            }
            else
            {
                // NORMAL TRIGGER

                int tgstab = int((1 - trigstab) * 100);
                if (tgstab > 95) tgstab = 100000;
                //Print(pDC,100,4, tgstab);

                do                                                  
                {
                    if (trigslope)
                    {
						// ------------------------------------------------ old noise
                        //for (px = px; px < samplesmax; px++)
                        //{
                        //    if (pCbufIn[readpos] > tglev + tgist) break;
                        //    readpos -= numCH;
                        //    if (readpos < 0) readpos += IN_CBUF_LEN;
                        //}
                        //for (px = px; px < samplesmax; px++)
                        //{ 
                        //    if (pCbufIn[readpos] <= tglev) break;
                        //    readpos -= numCH;
                        //    if (readpos < 0) readpos += IN_CBUF_LEN;
                        //}

						// ------------------------------------------------ new noise with sm and div
						//Print(pDC,100,4, tgist);
						static float sm = (float)pCbufIn[readpos];
						float div = (tgist / 100.0f) + 1;
						for (px = px; px < samplesmax; px++)
                        {
							sm += ((float)pCbufIn[readpos] - sm) / div;
                            if ((int)sm > tglev + tgist) break;
                            readpos -= numCH;
                            if (readpos < 0) readpos += IN_CBUF_LEN;
                        }
                        for (px = px; px < samplesmax; px++)
                        { 
							sm += ((float)pCbufIn[readpos] - sm) / div;
                            if ((int)sm  <= tglev) break;
                            readpos -= numCH;
                            if (readpos < 0) readpos += IN_CBUF_LEN;
						}

                    }
                    else
                    {
						// ------------------------------------------------ old noise
                        //for (px = px; px < samplesmax; px++)
                        //{
                        //    if (pCbufIn[readpos] < tglev - tgist) break;
                        //    readpos -= numCH;
                        //    if (readpos < 0) readpos += IN_CBUF_LEN;
                        //}
                        //for (px = px; px < samplesmax; px++)
                        //{ 
                        //    if (pCbufIn[readpos] >= tglev) break;
                        //    readpos -= numCH;
                        //    if (readpos < 0) readpos += IN_CBUF_LEN;
                        //}


						// ------------------------------------------------ new noise with sm and div
						//Print(pDC,100,4, tgist);
						static float sm = (float)pCbufIn[readpos];
						float div = (tgist / 100.0f) + 1;
						for (px = px; px < samplesmax; px++)
                        {
							sm += ((float)pCbufIn[readpos] - sm) / div;
                            if ((int)sm < tglev - tgist) break;
                            readpos -= numCH;
                            if (readpos < 0) readpos += IN_CBUF_LEN;
                        }
                        for (px = px; px < samplesmax; px++)
                        { 
							sm += ((float)pCbufIn[readpos] - sm) / div;
                            if ((int)sm  >= tglev) break;
                            readpos -= numCH;
                            if (readpos < 0) readpos += IN_CBUF_LEN;
                        }
                    }
                }
                while (abs(pCbufIn[readpos] - tglev) > tgstab && px < samplesmax);
            }
            triggered = (px < samplesmax);
        }
        trigsample = readpos;  
    }
    else
    {
        //readpos = trigsample + int(vispos * numCH); 
    }

	if (delayneg) readpos = trigsample + int(-vispos * numCH); 
	else  readpos = trigsample + int(vispos * numCH); 
	if (readpos > IN_CBUF_LEN) readpos = IN_CBUF_LEN;
	if (readpos < -IN_CBUF_LEN) readpos = -IN_CBUF_LEN;
			

    readpos -= int(sampPerScreen * trigpos);
    while (readpos < 0) readpos += IN_CBUF_LEN;

    //Print(pDC, 100, 100,  sweepStatus);
    //Print(pDC, 100, 100,  activeInBuffers);
    //Print(pDC, 100, 150,  activeOutBuffers);

    //*********************************************************
    //*  SWEEP CONTROL                                        *
    //*********************************************************
    if (analisistype == ANTYPE_SWEEP)
    {
        if (outputState && inputState && sweepStatus &&
            activeInBuffers <= 0 && activeOutBuffers <= 0)
        {
            if (!(GetAsyncKeyState(VK_LBUTTON) & 0x8000) ||
                !(regulationtype == 1 || regulationtype == 2 || regulationtype == 5))
            {             
                if (multiDraw) PlotSweepWave(pDC);

                // Se c'e' lo sweep multidraw si deve premere il tasto destro per far partire lo sweep
                if ((GetAsyncKeyState(VK_RBUTTON) & 0x8000) || !multiDraw)
                { 

                    if (sweepStatus == 2) ResetResponseTab();

                    ResetSweep(FALSE);
           
                    waveInReset(hwIn);
            
                    /*
                    int nbi = int(ceil(sweeptime * SAMPLES_PER_SEC / IN_BUF_LEN));
                    if (nbi > N_BUFIN) nbi = N_BUFIN;
                    */
                    for (int i = 0; i < N_BUFIN; i++) AddBuffer();

                        //waveOutReset(hwOut);
                    waveOutPause(hwOut);
                    int nbo = int(ceil(sweeptime * SAMPLES_PER_SEC / OUT_BUF_LEN));
                    if (nbo > N_BUFOUT) nbo = N_BUFOUT;
                    for (int i = 0; i < nbo; i++) FillBuffer(); 
                    
					waveInStart(hwIn);
                    waveOutRestart(hwOut);       
                    
					sweepStatus = 0;
                }

            }
        }
        readpos = 200 * numCH;
    }


    //*********************************************************
    //*  PULSE CONTROL                                        *
    //*********************************************************

    if ((analisistype == ANTYPE_FASTSW) || (analisistype == ANTYPE_PULSE))
	{
	
		// ============================================================================================
		//                                                                     search the pulse start
		// ============================================================================================
		
		// ------------------------------------------------------- start from cbufpos - PULSE_TOTAL_SAMPLES * 2
		readpos = cbufPos - PULSE_TOTAL_SAMPLES * 2;
		while (readpos < 0) readpos += IN_CBUF_LEN;
		
		// ------------------------------------------------------- search forward the maximum sample
		__int16 v; 
		__int16 vmax = 0;
		for (int i = 0; i < PULSE_TOTAL_SAMPLES; i ++)
        {
			if ((readpos += 1) >= IN_CBUF_LEN) readpos -= IN_CBUF_LEN;
            v = pCbufIn[readpos];
			v = __int16(abs(v));
			if (v > vmax)
			{
				vmax = v;
				pulseCbuffPos = readpos;
			}
        }

		// ------------------------------------------------------- search backward for 50mS below 10% of max
		int counter = 0;
		int countmax = int(SAMPLES_PER_SEC * 0.05);
		readpos = pulseCbuffPos;
		for (int i = 0; i < PULSE_TOTAL_SAMPLES; i ++)
		{
			if ((readpos -= 1) < 0) readpos += IN_CBUF_LEN;
			v = pCbufIn[readpos];
			v = __int16(abs(v));
			if (v > int(vmax * 0.1))
			{
				pulseCbuffPos = readpos;
				counter = 0;
			}
			else
			{
				if (counter++ > countmax) break;
			}
		}
		readpos = pulseCbuffPos;

		// ------------------------------------------------------- go another little time before
		if (analisistype == ANTYPE_FASTSW)
		{
			pulseCbuffPos = readpos - int(SAMPLES_PER_SEC * 0.05);	 // 100mS
		}
		else
		{
			pulseCbuffPos = readpos - int(SAMPLES_PER_SEC * 0.0002); // 200uS
		}


		// ============================================================================================
		//                                                                   Set the start positions
		// ============================================================================================
  
		if (!spectrumDisplay)
        {
			// ------------------------------------------------------------ VIEW SAMPLES
			readpos = pulseCbuffPos;
            readpos += numCH * int(SAMPLES_PER_SEC * start_sampling_ms / 1000);
            readpos -= int(sampPerScreen * trigpos);
			while (readpos < 0) readpos += IN_CBUF_LEN;
        }

	}

    
    //*********************************************************
    //*  DISPLAY WAVE                                         *
    //*********************************************************
  
    int v, readpos1, readpos2;

    if (numCH == 2) readpos &= 0xFFFFFFFE;



    int selection = selectCH;
    if (spectrumDisplay)
    {
        if (analisistype == ANTYPE_SWEEP) selection = 10;
		if ( (analisistype == ANTYPE_SPECTR)||
			 (analisistype == ANTYPE_FASTSW)||
			 (analisistype == ANTYPE_PULSE) ) selection = 11;
    }

    switch (selection)
    {
      //*********************************************************
      //*  CHANNEL 1 or CHANNEL 2                               *
      //*********************************************************
      case 0:
      case 1:   
      {  
        readpos1 = readpos;
        int py, ky;
        
        if (selectCH == 0)
        {
            py = py1;
            ky = ky1;
        }
        else
        {
            py = py2;
            ky = ky2;
            if (numCH == 2) readpos1 +=1;
        }

        pDC->MoveTo(0, py + ((pCbufIn[readpos1] * ky) >> 16));

        if (scaleX < 10)
        {
            for (px = step; px < (ddx << 14) + step; px += step)
            {
                if ((readpos1 += numCH) >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;

                v = pCbufIn[readpos1];
            
                pDC->LineTo(px >> 14, py + ((v * ky) >> 16));
            }
        }
        else
        {
            int pix = 0;
            int oldpix = -1;
            int min = 100000;
            int max = -100000;
            int ymin, ymax;

            for (px = step; px < ddx << 14; px += step)
            {      
                if ((readpos1 += numCH) >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                v = pCbufIn[readpos1];
           
                if (v > max) max = v;
                if (v < min) min = v;
    
                pix = px >> 14;
                if (pix > oldpix)
                {  
                    ymin = py + ((min * ky) >> 16);
                    ymax = py + ((max * ky) >> 16);
                    if (ymax > ymin)
                    {
                        pDC->MoveTo(pix, ymin);           
                        pDC->LineTo(pix, ymax);
                    }
                    else
                    {
                        pDC->SetPixelV(pix, ymin, trace);
                    }

                    min = 100000;
                    max = -100000;
                    oldpix = pix;
                }
            }
        }
      }
      break;


      //*********************************************************
      //*  CHANNEL 1  &  CHANNEL 2                              *
      //*********************************************************
      case 2:
      {
        readpos1 = readpos;
        readpos2 = readpos + int(scaleX * -deltapos * numCH);
        if (readpos2 < 0) readpos2 += IN_CBUF_LEN;
		if (readpos2 < 0) readpos2 = 0;
        if (numCH == 2) readpos2 += 1;

        int oldy1 = py1 + ((pCbufIn[readpos1] * ky1) >> 16);
        int oldy2 = py2 + ((pCbufIn[readpos2] * ky2) >> 16);
        int v1, v2;
        int oldx = 0;
        int xx;

        if (scaleX < 10)
        {
            for (px = step; px < (ddx << 14) + step; px += step)
            {
                if ((readpos1 += numCH) >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                if ((readpos2 += numCH) >= IN_CBUF_LEN) readpos2 -= IN_CBUF_LEN;

                v1 = pCbufIn[readpos1];
                v2 = pCbufIn[readpos2];                
              
                v1 = py1 + ((v1 * ky1) >> 16);
                v2 = py2 + ((v2 * ky2) >> 16);

                xx = px >> 14;
                pDC->MoveTo(oldx, oldy1);
                pDC->LineTo(xx, v1);
                pDC->MoveTo(oldx, oldy2);
                pDC->LineTo(xx, v2);

                oldy1 = v1;
                oldy2 = v2;
                oldx = xx;
            }
        }
        else
        {
            int pix = 0;
            int oldpix = -1;
            int min1 = 100000;
            int max1 = -100000;
            int min2 = 100000;
            int max2 = -100000;
            int ymin1, ymax1;
            int ymin2, ymax2;

            for (px = step; px < ddx << 14; px += step)
            {
                if ((readpos1 += numCH) >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                if ((readpos2 += numCH) >= IN_CBUF_LEN) readpos2 -= IN_CBUF_LEN;

                v1 = pCbufIn[readpos1];
                v2 = pCbufIn[readpos2];
                      
                if (v1 > max1) max1 = v1;
                if (v1 < min1) min1 = v1;
                if (v2 > max2) max2 = v2;
                if (v2 < min2) min2 = v2;

                pix = px >> 14;
                if (pix > oldpix)
                {  
                    ymin1 = py1 + ((min1 * ky1) >> 16);
                    ymax1 = py1 + ((max1 * ky1) >> 16);
                    ymin2 = py2 + ((min2 * ky2) >> 16);
                    ymax2 = py2 + ((max2 * ky2) >> 16);
                    
                    if (ymax1 > ymin1)
                    {
                        pDC->MoveTo(pix, ymin1);           
                        pDC->LineTo(pix, ymax1); 
                    }
                    else
                    {
                        pDC->SetPixelV(pix, ymin1, trace);       
                    }
                    if (ymax2 > ymin2)
                    {
                        pDC->MoveTo(pix, ymin2);           
                        pDC->LineTo(pix, ymax2); 
                    }
                    else
                    {
                        pDC->SetPixelV(pix, ymin2, trace);       
                    }
 
                    min1 = 100000;
                    max1 = -100000;
                    min2 = 100000;
                    max2 = -100000;
                    oldpix = pix;
                }
            }
        }
      }
      break;

      //*********************************************************
      //*  CHANNEL 1 + CHANNEL 2  (ADD)                         *
      //*********************************************************
      case 3:
      {
        readpos1 = readpos;
        readpos2 = readpos + int(scaleX * -deltapos * numCH);
        if (readpos2 < 0) readpos2 += IN_CBUF_LEN;
		if (readpos2 < 0) readpos2 = 0;
        if (numCH == 2) readpos2 += 1;

        int v1, v2;

        v1 = pCbufIn[readpos1];
        v2 = pCbufIn[readpos2];
        pDC->MoveTo(0, py1 + py2 - py + ((v1 * ky1) >> 16) + ((v2 * ky2) >> 16));

        if (scaleX < 10)
        {
            for (px = step; px < (ddx << 14) + step; px += step)
            {
                if ((readpos1 += numCH) >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                if ((readpos2 += numCH) >= IN_CBUF_LEN) readpos2 -= IN_CBUF_LEN;

                v1 = pCbufIn[readpos1];
                v2 = pCbufIn[readpos2];
       
                pDC->LineTo(px >> 14,
                            py1 + py2 - py +
                            ((v1 * ky1) >> 16) + ((v2 * ky2) >> 16));
            }
        }
        else
        {
            int pix = 0;
            int oldpix = -1;
           
            for (px = step; px < ddx << 14; px += step)
            {
                if ((readpos1 += numCH) >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                if ((readpos2 += numCH) >= IN_CBUF_LEN) readpos2 -= IN_CBUF_LEN;

                v1 = pCbufIn[readpos1];
                v2 = pCbufIn[readpos2];
       
                pix = px >> 14;
                if (pix > oldpix)
                {                   
                    pDC->LineTo(pix,
                                py1 + py2 - py +
                                ((v1 * ky1) >> 16) + ((v2 * ky2) >> 16));  

                    oldpix = pix;
                }
            }
        }
      }
      break;

      //*********************************************************
      //*  CHANNEL 1 - CHANNEL 2   (SUB)                        *
      //*********************************************************
      case 4:
      {
        readpos1 = readpos;
        readpos2 = readpos + int(scaleX * -deltapos * numCH);
        if (readpos2 < 0) readpos2 += IN_CBUF_LEN;
		if (readpos2 < 0) readpos2 = 0;
        if (numCH == 2) readpos2 += 1;

        int v1, v2;

        v1 = pCbufIn[readpos1];
        v2 = -pCbufIn[readpos2];
        pDC->MoveTo(0, py1 + py2 - py + ((v1 * ky1) >> 16) + ((v2 * ky2) >> 16));

        if (scaleX < 10)
        {
            for (px = step; px < (ddx << 14) + step; px += step)
            {
                if ((readpos1 += numCH) >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                if ((readpos2 += numCH) >= IN_CBUF_LEN) readpos2 -= IN_CBUF_LEN;

                v1 = pCbufIn[readpos1];
                v2 = -pCbufIn[readpos2];
                
                pDC->LineTo(px >> 14,
                            py1 + py2 - py +
                            ((v1 * ky1) >> 16) + ((v2 * ky2) >> 16));
            }
        }
        else
        {
            int pix = 0;
            int oldpix = -1;
           
            for (px = step; px < ddx << 14; px += step)
            {
                if ((readpos1 += numCH) >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                if ((readpos2 += numCH) >= IN_CBUF_LEN) readpos2 -= IN_CBUF_LEN;

                v1 = pCbufIn[readpos1];
                v2 = -pCbufIn[readpos2];
       
                pix = px >> 14;
                if (pix > oldpix)
                {                   
                 
                    pDC->LineTo(pix,
                                py1 + py2 - py +
                                ((v1 * ky1) >> 16) + ((v2 * ky2) >> 16));  

                    oldpix = pix;
                }
            }
        }
      }
      break;

      //*********************************************************
      //*  CHANNEL 1 = X  /  CHANNEL 2 = Y                      *
      //*********************************************************
      case 5:
      {
        readpos1 = readpos;
        readpos2 = readpos + int(scaleX * -deltapos * numCH);
        if (readpos2 < 0) readpos2 += IN_CBUF_LEN;
		if (readpos2 < 0) readpos2 = 0;
        if (numCH == 2) readpos2 += 1;

        int v1, v2;
        int px1 = ddx / 2 - 1 + int(posY1 * ddx);

        v1 = -pCbufIn[readpos1];
        v2 = pCbufIn[readpos2];
        pDC->MoveTo(((v1 * ky1) >> 16) + px1, ((v2 * ky2) >> 16) + py2);

        if (scaleX < 10)
        {
            for (px = step; px < ddx << 14; px += step)
            {
                if ((readpos1 += numCH) >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                if ((readpos2 += numCH) >= IN_CBUF_LEN) readpos2 -= IN_CBUF_LEN;

                v1 = -pCbufIn[readpos1];
                v2 = pCbufIn[readpos2];
                    
                pDC->LineTo(((v1 * ky1) >> 16) + px1, ((v2 * ky2) >> 16) + py2);
            }
        }
        else
        {
            int pix = 0;
            int oldpix = -1;
            
            for (px = step; px < ddx << 14; px += step)
            {
                if ((readpos1 += numCH) >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                if ((readpos2 += numCH) >= IN_CBUF_LEN) readpos2 -= IN_CBUF_LEN;

                v1 = -pCbufIn[readpos1];
                v2 = pCbufIn[readpos2];
                     
                pix = px >> 14;
                if (pix > oldpix)
                {              
                    pDC->LineTo(((v1 * ky1) >> 16) + px1, ((v2 * ky2) >> 16) + py2);                                      
                    oldpix = pix;
                }
            }
        }
      }
      break;

      //*********************************************************
      //*  SWEEP                                                *
      //*********************************************************
      case 10:
      {
        if (analisistype == ANTYPE_SWEEP && multiDraw && (GetAsyncKeyState(VK_LBUTTON) & 0x8000)) dcScreen.BitBlt(0, 0, ddx, ddy, &dcGrid, 0, 0, SRCCOPY);
        if (sweepStatus > 1 && inputState && outputState);
        else if (!multiDraw) PlotSweepWave(pDC);  
      }
      break;

      //*********************************************************
      //*  SPECTRUM  &  PULSE                                   *
      //*********************************************************
      case 11:
      {

		// ------------------------------------------ Execute the Fast Hartley Transform 
        // InitTime();
		if (analisistype == ANTYPE_SPECTR)
        {
			FHT(fht_samples);
		}
        else if (((analisistype == ANTYPE_FASTSW) || (analisistype == ANTYPE_PULSE)) && outputState ) 
        {
            if (pulseFlag)
            {
				FHT(fht_samples);
                pulseFlag = FALSE;
            }
        }
		else
		{
			FHT(fht_samples);
		}
        // Print (pDC, 250, 2, GetTime());



        int ix = 0;
        int y;
        double vv = 0;
        
        if (ylogtype)
        {
            double db;
                       
            for (px = leftborder; px < ddx; px ++) 
            {
                vv = responseTab[ix++];
                if (vv > -1) break;
            }
            db = kdb * log(vv / 32768.0);
            y = int((dispy * (db - dbmin) / (dbmax - dbmin)) + .5);
            if (y < 0) y = 0;
            pDC->MoveTo(leftborder, dispy - y);

            for (px; px < ddx; px ++)
            {        
                vv = responseTab[ix++];
                if (vv > -1)
                {
                    db = kdb * log(vv / 32768.0);
                    y = int((dispy * (db - dbmin) / (dbmax - dbmin)) + .5);
                    if (y < 0) y = 0;    
                    pDC->LineTo(px, dispy - y);
                }
            }
        }
        else
        {
            double kv = 2.0 / 32768;
            double vmin = 2 * exp(dbmin / kdb);
            double vmax = 2 * exp(dbmax / kdb);
            for (px = leftborder; px < ddx; px ++) 
            {
                vv = responseTab[ix++];
                if (vv > -1) break;
            }
            y = int((dispy * (vv * kv - vmin) / (vmax - vmin)) + .5);
            if (y < 0) y = 0;
            pDC->MoveTo(leftborder, dispy - y);

            for (px; px < ddx; px ++)
            {        
                vv = responseTab[ix++];
                if (vv > -1)
                {
                    y = int((dispy * (vv * kv - vmin) / (vmax - vmin)) + .5);
                    if (y < 0) y = 0;
                    pDC->LineTo(px, dispy - y);
                }
            }
        }

      }
      break;

    }
    //Print(pDC,100,6,vispos);

    //*********************************************************
    //*  SPECTRUM ANALYSIS AND SWEEP READOUT                  *
    //*********************************************************
    if (osdIntensity > 110 && analisistype >= ANTYPE_SPECTR && spectrumDisplay && curs1)
    {
        CFont font;
        font.CreateFont(14, 0, 0, 0, 700, 0, 0, 0, 0, 0, 0, CLEARTYPE_QUALITY, 0, "Arial");
        CFont* pOldFont = pDC->SelectObject(&font);
        pDC->SelectObject(&pentrig);
        pDC->SetBkMode (TRANSPARENT);
        pDC->SetTextColor(osdColor);
        CString s;
        double freq;

        if (xlogtype) freq = freqmin * exp(curs1 * log(freqmax / freqmin));
        else freq = freqmin + curs1 * (freqmax - freqmin);

        if (timetype)
        {               
            s.Format("%1.1f Hz", freq);
            pDC->TextOut(dispx - 30, 0, s);
        }
        else
        {           
            s.Format("%1.3f mS", 1000 / freq);
            pDC->TextOut(dispx - 40, 0, s);
        }

        
        int p = int(dispx * curs1);
        int x = leftborder + p;

        double vv;
        do
        {
            vv = responseTab[p];
            if (vv >= 0) break;
            p++; 
        }while (p < dispx);

        if (volttype)
        {
            if (vv > 0) s.Format("%2.1f dB", kdb * log(vv / 32768.0));
            else s.Format("- oo dB");
        }
        else
        {
            s.Format("%2.3f mVpp", vv * 2000.0 / 32768);
        }
        pDC->TextOut(leftborder + 6, 0, s);

        
        pDC->MoveTo(x, 14);           
        pDC->LineTo(x, dispy - 2);

        
        pDC->SelectObject(pOldFont);
    }

    //*********************************************************
    //*  SCOPE READOUT                                        *
    //*********************************************************
    if (osdIntensity > 110 && (analisistype < ANTYPE_SPECTR || !spectrumDisplay))
    {
        CFont font;
        font.CreateFont(15, 0, 0, 0, 700, 0, 0, 0, 0, 0, 0, CLEARTYPE_QUALITY, 0, "Arial");
        CFont* pOldFont = pDC->SelectObject(&font);
        pDC->SelectObject(&pentrig);
        pDC->SetBkMode (TRANSPARENT);
        pDC->SetTextColor(osdColor);
        CString s;
  
		if (analisistype == ANTYPE_SPECTR) pDC->TextOut(12,24,"Spectrum samples");
        if (analisistype == ANTYPE_SWEEP)  pDC->TextOut(12,24,"Sweep samples");
        if (analisistype == ANTYPE_FASTSW) pDC->TextOut(12,24,"FastSweep samples");
        if (analisistype == ANTYPE_PULSE)  pDC->TextOut(12,24,"Pulse samples");
        

        // CONTINUOUS VOLT-METER & FREQUENCY-METER
        if ((curstype == 1 || curstype == 2) && inputState)
        {
            if (curstype == 1) pDC->TextOut(20, 4, "CH 1");
            else pDC->TextOut(20, 4, "CH 2");
            vpepInst = (vmax - vmin) / 32.768;    // - .3;

            vpep = vpep + (vpepInst - vpep) / 10;
            
            if (volttype)
            {
                if (vpep > 0) s.Format("- %2.1f dB", 20 * log10(2000 / vpep));
                else s = "- oo dB";
            }
            else
            {
                if (vpep >= 100) s.Format("%1.3f Vpp", vpep / 1000);
                else s.Format("%2.1f mVpp", vpep);
            }
            pDC->TextOut(86,4,s);

            if (fmeterResultCycles)
            {
                double time = (double(fmeterResultSamples) / double(SAMPLES_PER_SEC)) / double(fmeterResultCycles);

                if (timetype)
                {  
					double freq = 1.0 / time;
					if (freq > 9000) s.Format("%1.1f Hz", freq);
                    else if (freq > 900) s.Format("%1.2f Hz", freq);
					else  s.Format("%1.3f Hz", freq);
                }
                else
                {      
                    s.Format("%1.4f mS", time * 1000);
                }
                pDC->TextOut(180,4,s);
            } 
			
			fmeterTrigUp = vmin + (vmax - vmin) * 7 / 10;
            fmeterTrigDown = vmin + (vmax - vmin) * 3 / 10;





        }
        else if (curstype == 3)
        {
            int x1, x2, v1, v2, vs, intp;
			int y1 = 0;
			int y2 = 0;
            double p;
           
            // CHANNEL 1 CURSORS
            if (selectCH == 0 || selectCH == 2)                 
            {
                p = sampPerScreen * curs1;
                intp = int(p);
                if (numCH == 2) intp &= 0xFFFFFFFE;
                readpos1 = readpos + intp;       
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                v1 = pCbufIn[readpos1];     
                readpos1 = readpos + intp + numCH;       
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                vs = pCbufIn[readpos1]; 
                v1 += int((vs - v1) * (p - intp) / numCH);
                
                p = sampPerScreen * curs2;
                intp = int(p);
                if (numCH == 2) intp &= 0xFFFFFFFE;        
                readpos1 = readpos + intp;       
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                v2 = pCbufIn[readpos1];    
                readpos1 = readpos + intp + numCH;       
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                vs = pCbufIn[readpos1];
                v2 += int((vs - v2) * (p - intp) / numCH);

                y1 = py1 + ((v1 * ky1) >> 16);
                y2 = py1 + ((v2 * ky1) >> 16);

                if (curs1 == 0) {v1 = 0; y1 = py1;}
                if (curs2 == 0) {v2 = 0; y2 = py1;}

                x1 = int(ddx * curs1);
                x2 = int(ddx * curs2);
       
                pDC->MoveTo(x1 - 5, y1);           
                pDC->LineTo(x1 + 5, y1);
                pDC->MoveTo(x1, y1 + 5);           
                pDC->LineTo(x1, y1 - 5);

                pDC->MoveTo(x2 - 5, y2);           
                pDC->LineTo(x2 + 5, y2);
                pDC->MoveTo(x2, y2 + 5);           
                pDC->LineTo(x2, y2 - 5);
                       
                if (curs1 == 0) {x1 += 6; y1 += 30;}
                if (curs2 == 0) {x2 += 7; y2 += 42;}
                pDC->TextOut(x1 - 4, y1 - 28, "1");
                pDC->TextOut(x2 - 4, y2 - 28, "2");

                pDC->MoveTo(0, py1);           
                pDC->LineTo(5, py1);

                vpep = abs(v2 - v1) / 32.768;

                if (volttype)
                {
                    if (vpep > 0) s.Format("- %2.1f dB", 20 * log10(2000 / vpep));
                    else s = "- oo dB";
                }
                else
                {
                    if (vpep >= 100) s.Format("%1.3f Vpp", vpep / 1000);
                    else s.Format("%2.1f mVpp", vpep);
                }
                pDC->TextOut(16, 4, "CH1 " + s);
            }


            // CHANNEL 2 CURSORS
            if (selectCH == 1 || selectCH == 2)
            {
                readpos2 = readpos;
                if (selectCH == 2)
                {
                    readpos2 += int(scaleX * -deltapos * numCH);
                    if (readpos2 < 0) readpos2 += IN_CBUF_LEN;
					if (readpos2 < 0) readpos2 = 0;
                }

                p = sampPerScreen * curs1;
                intp = int(p);
                if (numCH == 2) intp &= 0xFFFFFFFE;
                readpos1 = readpos2 + intp;
                if (numCH == 2) readpos1 ++;
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                v1 = pCbufIn[readpos1];    
                readpos1 = readpos2 + intp + numCH;
                if (numCH == 2) readpos1 ++;
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN; 
                vs = pCbufIn[readpos1]; 
                v1 += int((vs - v1) * (p - intp) / numCH);
                
                p = sampPerScreen * curs2;
                intp = int(p);
                if (numCH == 2) intp &= 0xFFFFFFFE;
                readpos1 = readpos2 + intp;
                if (numCH == 2) readpos1 ++;
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;         
                v2 = pCbufIn[readpos1];        
                readpos1 = readpos2 + intp + numCH; 
                if (numCH == 2) readpos1 ++;
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                vs = pCbufIn[readpos1]; 
                v2 += int((vs - v2) * (p - intp) / numCH);


                y1 = py2 + ((v1 * ky2) >> 16);
                y2 = py2 + ((v2 * ky2) >> 16);

                
                if (curs1 == 0) {v1 = 0; y1 = py2;}
                if (curs2 == 0) {v2 = 0; y2 = py2;}

                x1 = int(ddx * curs1);
                x2 = int(ddx * curs2);
       
                pDC->MoveTo(x1 - 5, y1);           
                pDC->LineTo(x1 + 5, y1);
                pDC->MoveTo(x1, y1 + 5);           
                pDC->LineTo(x1, y1 - 5);

                pDC->MoveTo(x2 - 5, y2);           
                pDC->LineTo(x2 + 5, y2);
                pDC->MoveTo(x2, y2 + 5);           
                pDC->LineTo(x2, y2 - 5);
                       
                if (curs1 == 0) {x1 += 6; y1 += 30;}
                if (curs2 == 0) {x2 += 7; y2 += 42;}
                pDC->TextOut(x1 - 4, y1 - 28, "1");
                pDC->TextOut(x2 - 4, y2 - 28, "2");

                pDC->MoveTo(0, py2);           
                pDC->LineTo(5, py2);

                vpep = abs(v2 - v1) / 32.768;

                if (volttype)
                {
                    if (vpep > 0) s.Format("- %2.1f dB", 20 * log10(2000 / vpep));
                    else s = "- oo dB";
                }
                else
                {
                    if (vpep >= 100) s.Format("%1.3f Vpp", vpep / 1000);
                    else s.Format("%2.1f mVpp", vpep);
                }
                pDC->TextOut(128, 4, "CH2 " + s);
            }


            // ADD SUB & XY CURSORS
            if (selectCH > 2)                 
            {
                p = sampPerScreen * curs1;
                intp = int(p);
                if (numCH == 2) intp &= 0xFFFFFFFE;
                readpos1 = readpos + intp;       
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                v1 = pCbufIn[readpos1];         
                readpos1 = readpos + intp + numCH;       
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                vs = pCbufIn[readpos1];  
                v1 += int((vs - v1) * (p - intp) / numCH);
                
                p = sampPerScreen * curs2;
                intp = int(p);
                if (numCH == 2) intp &= 0xFFFFFFFE;
                readpos1 = readpos + intp;       
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                v2 = pCbufIn[readpos1];            
                readpos1 = readpos + intp + numCH;       
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                vs = pCbufIn[readpos1];     
                v2 += int((vs - v2) * (p - intp) / numCH);

                int v3, v4;          
                readpos2 = readpos + int(scaleX * -deltapos * numCH);
                if (readpos2 < 0) readpos2 += IN_CBUF_LEN;
				if (readpos2 < 0) readpos2 = 0;
               
                p = sampPerScreen * curs1;
                intp = int(p);
                if (numCH == 2) intp &= 0xFFFFFFFE;
                readpos1 = readpos2 + intp;
                if (numCH == 2) readpos1 ++;
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                v3 = pCbufIn[readpos1];    
                readpos1 = readpos2 + intp + numCH;
                if (numCH == 2) readpos1 ++;
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN; 
                vs = pCbufIn[readpos1]; 
                v3 += int((vs - v3) * (p - intp) / numCH);
                
                p = sampPerScreen * curs2;
                intp = int(p);
                if (numCH == 2) intp &= 0xFFFFFFFE;
                readpos1 = readpos2 + intp;
                if (numCH == 2) readpos1 ++;
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;         
                v4 = pCbufIn[readpos1];        
                readpos1 = readpos2 + intp + numCH; 
                if (numCH == 2) readpos1 ++;
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                vs = pCbufIn[readpos1]; 
                v4 += int((vs - v4) * (p - intp) / numCH);

                if (selectCH == 3)
                {
                    y1 = py1 + py2 - py + ((v1 * ky1) >> 16) + ((v3 * ky2) >> 16);
                    y2 = py1 + py2 - py + ((v2 * ky1) >> 16) + ((v4 * ky2) >> 16);
                    v1 += v3;
                    v2 += v4;
                }
                else if (selectCH == 4)
                {
                    y1 = py1 + py2 - py + ((v1 * ky1) >> 16) - ((v3 * ky2) >> 16);
                    y2 = py1 + py2 - py + ((v2 * ky1) >> 16) - ((v4 * ky2) >> 16);
                    v1 -= v3;
                    v2 -= v4;
                }

                
                if (selectCH == 5)
                {
                    int px1 = ddx / 2 - 1 + int(posY1 * ddx);
                    x1 = px1 - ((v1 * ky1) >> 16);
                    x2 = px1 - ((v2 * ky1) >> 16);
                    y1 = py2 + ((v3 * ky2) >> 16);
                    y2 = py2 + ((v4 * ky2) >> 16);
                    
                    vpep = abs(v2 - v1) / 32.768;
                          
                    if (volttype)
                    {
                        if (vpep > 0) s.Format("- %2.1f dB", 20 * log10(2000 / vpep));
                        else s = "- oo dB";
                    }
                    else
                    {
                        if (vpep >= 100) s.Format("%1.3f Vpp", vpep / 1000);
                        else s.Format("%2.1f mVpp", vpep);
                    }
                    pDC->TextOut(8, 4, "dX " + s);

                    vpep = abs(v4 - v3) / 32.768;
            
                    if (volttype)
                    {
                        if (vpep > 0) s.Format("- %2.1f dB", 20 * log10(2000 / vpep));
                        else s = "- oo dB";
                    }
                    else
                    {
                        if (vpep >= 100) s.Format("%1.3f Vpp", vpep / 1000);
                        else s.Format("%2.1f mVpp", vpep);
                    }
                    pDC->TextOut(116, 4, "dY " + s);
                }
                else
                {
                    x1 = int(ddx * curs1);
                    x2 = int(ddx * curs2);
                    
                    if (curs1 == 0) {v1 = 0; y1 = py1 + py2 - py;}
                    if (curs2 == 0) {v2 = 0; y2 = py1 + py2 - py;}

                    
                    pDC->MoveTo(0, py1 + py2 - py);           
                    pDC->LineTo(5, py1 + py2 - py);
           
                    vpep = abs(v2 - v1) / 32.768;
      
                    if (volttype)
                    {
                        if (vpep > 0) s.Format("- %2.1f dB", 20 * log10(2000 / vpep));
                        else s = "- oo dB";
                    }
                    else
                    {
                        if (vpep >= 100) s.Format("%1.3f Vpp", vpep / 1000);
                        else s.Format("%2.1f mVpp", vpep);
                    }
                    
                    CString s2 = "";
                    if (ky1 != ky2)
                    {
                        double rapp = 100 * (scaleY1 / regY1) / (scaleY2 / regY2);
                        if (rapp < 100 && regY1 != regY2) s2.Format("%2.3f%% of ", rapp);
                        else s2.Format("%2.1f%% of ", rapp);   
                    }

                    if (selectCH == 3) s = "CH1 + " + s2 + "CH2  = " + s;
                    else s = "CH1 - " + s2 + "CH2  = " + s;

                    pDC->TextOut(16, 4, s);
                }
       
                pDC->MoveTo(x1 - 5, y1);           
                pDC->LineTo(x1 + 5, y1);
                pDC->MoveTo(x1, y1 + 5);           
                pDC->LineTo(x1, y1 - 5);

                pDC->MoveTo(x2 - 5, y2);           
                pDC->LineTo(x2 + 5, y2);
                pDC->MoveTo(x2, y2 + 5);           
                pDC->LineTo(x2, y2 - 5);
                       
                if (curs1 == 0) {x1 += 6; y1 += 30;}
                if (curs2 == 0) {x2 += 7; y2 += 42;}
                pDC->TextOut(x1 - 4, y1 - 28, "1");
                pDC->TextOut(x2 - 4, y2 - 28, "2");
            }
     
            // TIME & FREQ
            double time = scaleX / regX * fabs(curs2 - curs1) / 100.0;
     
            if (timetype)
            {   
                if (time <= 0.00001) s = "1/dT = ? Hz";
                else s.Format("1/dT = %1.1f Hz", 1 / time);
            }
            else
            {           
                s.Format("dT = %1.3f mS", time * 1000);
            }
            pDC->TextOut(240,4,s);
        }

        
        // LOWER ROW - SCALE X / SCALE Y / DELAY
        if (selectCH != 1)
        {
            if (scaleY1 / regY1 != int(scaleY1 / regY1)) s.Format("%3.2f mV", scaleY1 / regY1);
            else s.Format("%3.0f mV", scaleY1 / regY1);
            pDC->TextOut(8, 246, s);
            s = "";
            if (gnd1 == 0) s = "- ";
            else if (gnd1 == 2) s = "Gnd ";
            if (regY1 != 1) s += "Uncal";
            pDC->TextOut(8, 234, s);
        }

        if (selectCH > 0)
        {
            if (scaleY2 / regY2 != int(scaleY2 / regY2)) s.Format("%3.2f mV", scaleY2 / regY2);
            else s.Format("%3.0f mV", scaleY2 / regY2);
            pDC->TextOut(78, 246, s);
            s = "";
            if (gnd2 == 0) s = "- ";
            else if (gnd2 == 2) s = "Gnd ";
            if (regY2 != 1) s += "Uncal";
            pDC->TextOut(78, 234, s);
        }

    
        double sx = 1000 * scaleX / regX;
        if (sx != int(sx))
        {
            if (sx < 1000) s.Format("%3.1f uS", sx);
            else s.Format("%3.1f mS", sx / 1000);
            pDC->TextOut(296, 246, s);
        }
        else
        {
            if (sx < 1000) s.Format("%3.0f uS", sx);
            else s.Format("%3.0f mS", sx / 1000);
            pDC->TextOut(298, 246, s);
        }
        if (regX != 1) pDC->TextOut(298, 234, "Uncal");
    
        if (vispos != 0 && analisistype < ANTYPE_SPECTR)
        {
            double delay = vispos * 1000.0 / SAMPLES_PER_SEC;

            if (delay < 1) s.Format("%3.0f uS", delay * 1000);
            else if (delay < 10) s.Format("%2.2f mS", delay);
            else if (delay < 1000) s.Format("%2.1f mS", delay);   
            else s.Format("%1.4f S", delay/1000);
            pDC->TextOut(148, 246, "Dly " + s);
        }

        if (deltapos != 0 && selectCH >= 2)
        {
            double delay = scaleX * deltapos * 1000.0 / SAMPLES_PER_SEC;

            if (delay < 1) s.Format("%3.0f uS", delay * 1000);
            else if (delay < 10) s.Format("%2.2f mS", delay);
            else if (delay < 1000) s.Format("%2.1f mS", delay);   
            else s.Format("%1.4f S", delay/1000);
            pDC->TextOut(228, 246, "dT " + s);
        }
   
      

        //*********************************************************
        //*  TRIGGER MARKER                                       *
        //*********************************************************
            
        if (selectCH < 5)
        {
            int trigx, trigy, trigtype;
            trigx = int(ddx * trigpos);
        
            if (inputState)
            {
                if (trigCH) trigy = py2 + ((tglev * ky2) >> 16);
                else trigy = py1 + ((tglev * ky1) >> 16);
                trigtype = trigslope; 
            }
            else
            {
                trigy = ddy - 30;
                trigtype = 1;
            }

            if (trigslope)
            {
                pDC->MoveTo(trigx, trigy - 10);           
                pDC->LineTo(trigx, trigy + 10);
                pDC->LineTo(trigx + 3, trigy + 7);
                pDC->MoveTo(trigx, trigy + 10); 
                pDC->LineTo(trigx - 3, trigy + 7);
            }
            else
            {
                pDC->MoveTo(trigx, trigy + 10);           
                pDC->LineTo(trigx, trigy - 10);
                pDC->LineTo(trigx + 3, trigy - 7);
                pDC->MoveTo(trigx, trigy - 10); 
                pDC->LineTo(trigx - 3, trigy - 7);
            }


			if ((analisistype == ANTYPE_SPECTR) || (analisistype == ANTYPE_FASTSW) || (analisistype == ANTYPE_PULSE))
			{
				int w = 0; 
				if (analisistype == ANTYPE_SPECTR) w = int(fht_samples * 1000 / SAMPLES_PER_SEC * 35 / (scaleX / regX));
				if (analisistype == ANTYPE_FASTSW) w = int(fht_samples * 1000 / SAMPLES_PER_SEC * 35 / (scaleX / regX));
				if (analisistype == ANTYPE_PULSE) w = int(sampling_ms * 35 / (scaleX / regX));
				pDC->MoveTo(trigx, 230);           
                pDC->LineTo(trigx + w, 230);
				pDC->MoveTo(trigx, 225);           
                pDC->LineTo(trigx, 236);
				pDC->MoveTo(trigx+w, 225);           
                pDC->LineTo(trigx+w, 236);
			}

        }
        pDC->SelectObject(pOldFont);
    }
    
    pDC->SelectObject(pOldPen);   
}








/*================================================================================
===== CDaa ====================================|  CLASS                           |
                                                ==================================
   Description    .                     
=================================================================================*/

void DAA_Init()
{
    ReadIni();

    freq = 100;
    freqmin = 10;
    freqmax = 20000;
    sweeptime = 5;
    start_sampling_ms = 0;
    sampling_ms = out_pulse_millisec;

    duty = 50;
    burstcycles = 10;
    pausecycles = 10;
    dbmin = -50;
    dbmax = 0;
    outlevel = 0;
    
    scaleX = 2;  
    scaleY1 = 200;
    scaleY2 = 200;
    regX = 1;
    regY1 = 1;
    regY2 = 1;
    posY1 = 0;
    posY2 = 0;

    selectCH = 0;
    gnd1 = 1;
    gnd2 = 1;
    trigCH = 0;

    inputState = 0;
    outputState = 0;

    wavetype = WAVETYPE_SINE;
    analisistype = ANTYPE_WAVE;
    regulationtype = 0;
    
    gridLight = 20;
    osdIntensity = 180;
    traceIntensity = 240;

    trigtype = 2;
    trigvoid = 0;
    trigpos = .1;
    triglev = 0;
    trigist = 0;//.5;  << TrigNoise
    trigstab = 0;
    trigslope = FALSE;
    trigburst = FALSE;

	delayneg = FALSE;

    curs1 = 0;
    curs2 = 0;
    responsespeed = .5;
    curstype = 0;
    timetype = 0;
    volttype = 0;
    xlogtype = 1;
    ylogtype = 1;

    vispos = 0;
    deltapos = 0;
    control = 0;   
    numCH = 1;

    bandwidth = 0;

    spectrumDisplay = TRUE;
    multiDraw = FALSE;
    spectrum3D = FALSE;


    ////////////////////////////////////
    DAA_SetBandwidth(bandwidth);
    DAA_FillWaveTable(wavetype);
    InitTime();

    DAA_InputOn(inputState);
    DAA_OutputOn(outputState, TRUE);
}



void DAA_End()
{
    WriteIni();
    DAA_InputOff();
    DAA_OutputOff();
    
    // memory leaks ????????????
    //InitTime();
    //while (GetTime() < 2000000);
    ////////////////////////////
}


void DAA_InitObjects()
{
    /* 
    LPLOGPALETTE lpLogPal;
	lpLogPal = (LPLOGPALETTE) new BYTE[sizeof(LOGPALETTE) + ((32) * sizeof(PALETTEENTRY))];
	lpLogPal->palVersion = 0x0300;
	lpLogPal->palNumEntries = 32;  
    int i = 0;
    lpLogPal->palPalEntry[i].peRed = GetRValue(pressed);
    lpLogPal->palPalEntry[i].peGreen = GetGValue(pressed);
    lpLogPal->palPalEntry[i].peBlue = GetBValue(pressed);
    lpLogPal->palPalEntry[i].peFlags = NULL;
    i++;
    lpLogPal->palPalEntry[i].peRed = GetRValue(dback);
    lpLogPal->palPalEntry[i].peGreen = GetGValue(dback);
    lpLogPal->palPalEntry[i].peBlue = GetBValue(dback);
    lpLogPal->palPalEntry[i].peFlags = NULL;

    palette.CreatePalette(lpLogPal);
    delete lpLogPal;
    */

     
    // MAIN FRAME
    daaFrame.Init(2, 2, CLIENT_X - 8, CLIENT_Y - 39, 16, black, grey6);


    // LEFT PANEL
    int panelX = 10;
    int panelY = 8;

    frame1.Init(panelX, panelY, 60, 329, 16, grey3, panels);

    dialer1.Init(panelX + 29, panelY + 42, 19, 12, 4);
    dialer1.InitRange(0, 230, 1, 1, 1, &gridLight);
    dialer1.InitScale(40, 320, 2);
    dialer1.InitTitle(-16, -36, 0, 14, 0, "Arial", grey1, grey1, true, "SCALE");
	dialer1.InitScaleText(-7, 9, -1, 0, 11, 0, "Arial", grey1, grey1, true, "MIN,MAX");

    dialer2.Init(panelX + 29, panelY + 122, 19, 12, 4);
    dialer2.InitRange(100, 200, 1, 1, 1, &osdIntensity);
    dialer2.InitScale(40, 320, 2);
    dialer2.InitTitle(-23, -36, 0, 14, 0, "Arial", grey1, grey1, true, "READOUT");
	dialer2.InitScaleText(-7, 9, -1, 0, 11, 0, "Arial", grey1, grey1, true, "OFF,MAX");

    dialer3.Init(panelX + 29, panelY + 206, 19, 12, 4);
    dialer3.InitRange(175, 255, 1, 1, 1, &traceIntensity);
    dialer3.InitScale(40, 320, 2);
    dialer3.InitTitle(-16, -36, 0, 14, 0, "Arial", grey1, grey1, true, "TRACE");
	dialer3.InitScaleText(-7, 9, -1, 0, 11, 0, "Arial", grey1, grey1, true, "MIN,MAX");

    keysamp.Init(panelX + 32, panelY + 266, 16 , 14, 1, 0);
    keysamp.InitText("SAMPLES", -22, -13, 0, 11, 0, grey2, grey2, false, "Arial");
    keysamp.InitColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, white, black);

    keycal.Init(panelX + 32, panelY + 302, 16 , 14, 1, 0);
    keycal.InitText("CALIBRATE", -24, -13, 0, 11, 0, grey2, grey2, false, "Arial");
    keycal.InitColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, white, black);

    ledcal.Init(panelX + 10, panelY + 303, 13, 13, 2);
    ledcal.InitColors(grey5, RGB(255, 60, 60), RGB(60, 255, 60), RGB(60,60,60), RGB(220,220,140));
    ledcal.InitReflex(6,5,1,1);


    // ON-OFF PANEL
    panelX = 10;
    panelY = 341;

    kbInOnOff.Init(panelX, panelY, 37, 20, 2, 1, TRUE, 1);
    kbInOnOff.InitFrame(10, 18, 9, 74, 16);
    kbInOnOff.InitColors( grey3, panels);
    kbInOnOff.InitKeyColors(grey4, grey4, col_lighted_border, grey6, grey5, col_pressed, grey3, grey7, grey8, black);
    kbInOnOff.InitKeyFont("Arial", true, 0, 12, 0, grey0, grey0);
	kbInOnOff.keypressed = inputState;
    kbInOnOff.AddKey("OFF", 10, 6);
    kbInOnOff.AddKey("Mono", 7, 6);
    kbInOnOff.AddKey("Stereo", 6, 6);
    kbInOnOff.InitTitle(7, -14, 0, 14, 0, "Arial", grey1, grey1, true, "INPUT");
   
    kbOutOnOff.Init(panelX, panelY, 37, 20, 2, 1, TRUE, 1);
    kbOutOnOff.InitFrame(10, 110, 0, 0, 0);
    kbOutOnOff.InitColors( grey3, panels);
    kbOutOnOff.InitKeyColors(grey4, grey4, col_lighted_border, grey6, grey5, col_pressed, grey3, grey7, grey8, black);
    kbOutOnOff.InitKeyFont("Arial", true, 0, 12, 0, grey0, grey0);
	kbOutOnOff.keypressed = outputState;
    kbOutOnOff.AddKey("OFF", 10, 6);
    kbOutOnOff.AddKey("ON", 12, 6);
    kbOutOnOff.InitTitle(1, -14, 0, 14, 0, "Arial", grey1, grey1, true, "OUTPUT");


    // CHANNEL 1 & 2 PANEL
    panelX = 75;
    panelY = 341;

    frame2.Init(panelX , panelY, 308, 166, 16, grey3, panels);
    frame2.InitTitle(8, 75, 0, 16, 0, "Arial", grey3, grey3, true,
    "CH1                                                             CH2");
    dialer4.Init(panelX + 96, panelY + 97, 40, 33, 4);
    dialer4.InitRange(.1, 100, 1, 1, 1, &scaleY1);
    dialer4.InitScale(40, 320, 12);
    dialer4.InitScaleText(-10, -4, 10, 0, 11, 0, "Tahoma", grey1, grey1, true,
                          "500,250,200,100,  50,  25,  20,  10,   5,  2.5,    2,    1");
    dialer4.InitScaleValues("500,250,200,100,50,25,20,10,5,2.5,2,1");
    dialer4.InitTitle(-22, 48, 0, 16, 0, "Arial", grey1, grey1, true, "mV / Div");  
    dialer4.InitDual(26, 17, 5);
    dialer4.InitRangeDual(1, 2, 1, .001, .001, &regY1);
    dialer4.InitScaleDual(30, 325, 1);

    dialer5.Init(panelX + 219, panelY + 97, 40, 33, 4);
    dialer5.InitRange(.1, 100, 1, 1, 1, &scaleY2);
    dialer5.InitScale(40, 320, 12);
    dialer5.InitScaleText(-10, -4, 10, 0, 11, 0, "Tahoma", grey1, grey1, true,
                          "500,250,200,100,  50,  25,  20,  10,   5,  2.5,    2,    1");
    dialer5.InitScaleValues("500,250,200,100,50,25,20,10,5,2.5,2,1");
    dialer5.InitTitle(-22, 48, 0, 16, 0, "Arial", grey1, grey1, true, "mV / Div");
    dialer5.InitDual(26, 17, 5);
    dialer5.InitRangeDual(1, 2, 1, .001, .001, &regY2);
    dialer5.InitScaleDual(30, 325, 1);

    dialer6.Init(panelX + 32, panelY + 29, 21, 14, 4);
    dialer6.InitRange(-3, 3, 1.4, .0002, .001, &posY1);
    dialer6.InitTitle(-20, 26, 0, 14, 0, "Tahoma", grey3, grey3, true, "Ypos");
    
    dialer7.Init(panelX + 276, panelY + 29, 21, 14, 4);
    dialer7.InitRange(-3, 3, 1.4, .0002, .001, &posY2);
    dialer7.InitTitle(-4, 26, 0, 14, 0, "Tahoma", grey3, grey3, true, "Ypos");
    
    kbChan.Init(panelX + 80, panelY + 19, 22, 14, 2, -1, FALSE, 1);
    kbChan.InitFrame(0, 0, 0, 0, 0);
    kbChan.InitColors(grey3, panels);
    kbChan.InitKeyColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);
	kbChan.InitKeyFont("Tahoma", false, 0, 12, 0, grey0, grey0);
    kbChan.keypressed = selectCH;
    kbChan.AddKey("CH1", 3, -14);
    kbChan.AddKey("CH2", 3, -14);
    kbChan.AddKey("1+2", 5, -14);
    kbChan.AddKey("ADD", 3, -14);
    kbChan.AddKey("SUB", 3, -14);
    kbChan.AddKey("X-Y", 6, -14);

    kbGnd1.Init(panelX + 9, panelY + 113, 22, 14, 1, -1, TRUE, 1);
    kbGnd1.InitFrame(0, 0, 0, 0, 0);
    kbGnd1.InitColors(grey3, panels);
    kbGnd1.InitKeyColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);
	kbGnd1.InitKeyFont("Tahoma", true, 0, 11, 0, grey0, grey0);
    kbGnd1.keypressed = gnd1;   
    kbGnd1.AddKey("Neg", 4, 2);
    kbGnd1.AddKey("Pos", 4, 2);
    kbGnd1.AddKey("Gnd", 3, 3);
   
    kbGnd2.Init(panelX + 276, panelY + 113, 22, 14, 1, -1, TRUE, 1);
    kbGnd2.InitFrame(0, 0, 0, 0, 0);
    kbGnd2.InitColors(grey3, panels);
    kbGnd2.InitKeyColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);
	kbGnd2.InitKeyFont("Tahoma", true, 0, 11, 0, grey0, grey0);
    kbGnd2.keypressed = gnd1; 
    kbGnd2.AddKey("Neg", 4, 2);
    kbGnd2.AddKey("Pos", 4, 2);
    kbGnd2.AddKey("Gnd", 3, 3);

    
    // TRIGGER PANEL 
    panelX = 484;
    panelY = 8;

    DAA_SetTrigType(trigtype);
    dialerTrig.Init(panelX + 100, panelY + 108, 25, 16, 5);
   
    kbTrig.Init(panelX, panelY, 17, 17, 2, -1, TRUE, 1);
    kbTrig.InitFrame(42, 29, 72, 10, 16);
    kbTrig.InitColors(grey3, panels);
    kbTrig.InitKeyColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);
	kbTrig.InitKeyFont("Tahoma", false, 0, 12, 0, grey0, grey0);
    kbTrig.keypressed = trigtype;
    kbTrig.AddKey("OFF",   -33, 5);
    kbTrig.AddKey("X POS", -33, 5);
    kbTrig.AddKey("LEVEL", -33, 5);
    kbTrig.AddKey("NOISE", -33, 5);
    kbTrig.AddKey("STAB", -33, 5);
    kbTrig.frame.InitTitle(32, 6, 0, 15, 0, "Arial", grey1, grey1, true, "TRIGGER");
  
    ledtrig.Init(panelX + 10, panelY + 7, 15, 11, 1);
    ledtrig.InitColors(grey5, RGB(60, 255, 60), 0, RGB(60,60,60), RGB(240,240,160));
    ledtrig.InitReflex(5,4,1,1);
    ledtrig.square = TRUE;

    kbChtrig.Init(panelX + 75, panelY + 24, 25, 14, 1, -1, FALSE, 1);
    kbChtrig.InitFrame(0, 0, 0, 0, 0);
    kbChtrig.InitColors(grey3, panels);
    kbChtrig.InitKeyColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);
	kbChtrig.InitKeyFont("Tahoma", true, 0, 12, 0, grey0, grey0);
    kbChtrig.keypressed = trigCH;
    kbChtrig.AddKey("CH1", 3, 2);
    kbChtrig.AddKey("CH2", 3, 2);
    
    key1.pressed = trigslope;
    key1.Init(panelX + 110, panelY + 43, 16, 14, 1, 0);
    key1.InitText("SLOPE", -36, 3, 0, 12, 0, grey0, grey0, false, "Tahoma");
    key1.InitColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);

    key2.pressed = trigburst;
    key2.Init(panelX + 110, panelY + 60, 16, 14, 1, 0);
    key2.InitText("BURST", -36, 3, 0, 12, 0, grey0, grey0, false, "Tahoma");
    key2.InitColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);

  
    // ANALYSIS PANEL
    kbAtype.Init(624, 8, 17, 16, 1, -1, TRUE, 1);
    kbAtype.InitFrame(45, 29, 9, 8, 16);
    kbAtype.frame.InitTitle(8, 6, 0, 15, 0, "Arial", grey1, grey1, true, "ANALYSIS");
    kbAtype.InitColors(grey3, grey6);
    kbAtype.InitKeyColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);
	kbAtype.InitKeyFont("Tahoma", false, 0, 12, 0, grey0, grey0);
    kbAtype.keypressed = analisistype;
    kbAtype.AddKey("WAVE",  -38, 5);
    kbAtype.AddKey("BURST", -38, 5);
    kbAtype.AddKey("Spectr.", -38, 5);
    kbAtype.AddKey("Sweep", -38, 5);
    kbAtype.AddKey("FastSw.", -38, 5);
    kbAtype.AddKey("Pulse", -38, 5);
    
    
    // WAVE PANEL
    kbWtype.Init(702, 8, 17, 16, 1, -1, TRUE, 1);
    kbWtype.InitFrame(51, 29, 9, 8, 16);
    kbWtype.frame.InitTitle(6, 6, 0, 15, 0, "Arial", grey1, grey1, true, "WAVEFORM");
    kbWtype.InitColors(grey3, wavepanel);
    kbWtype.InitKeyColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);
	kbWtype.InitKeyFont("Tahoma", false, 0, 12, 0, grey0, grey0);
    kbWtype.keypressed = wavetype;
    kbWtype.AddKey("SINE",   -43, 5);
    kbWtype.AddKey("TRIANG", -43, 5);
    kbWtype.AddKey("RAMP +", -43, 5);
    kbWtype.AddKey("RAMP -", -43, 5);
    kbWtype.AddKey("SQUARE", -43, 5);
    kbWtype.AddKey("NOISE", -43, 5);
    

    // REGULATIONS PANEL
    panelX = 484;
    panelY = 152;
    
    DAA_SetRegulationType(regulationtype);
    dialer.Init(panelX + 218, panelY + 110, 60, 46, 8);
    indicator.Init(panelX + 162, panelY + 16);
   
    kbRtype.Init(panelX, panelY, 46, 20, 2, 1, TRUE, 1);
    kbRtype.InitFrame(18, 26, 229, 10, 16);
    kbRtype.InitColors( grey3, panels);
    kbRtype.InitKeyColors(grey4, grey4, col_lighted_border, grey6, grey5, col_pressed, grey3, grey7, grey8, black);
    kbRtype.InitKeyFont("Tahoma", true, 0, 12, 0, grey0, grey0);
	kbRtype.keypressed = regulationtype;
    kbRtype.AddKey("FREQ", 6, 6);
    kbRtype.AddKey("FMAX", 6, 6);
    kbRtype.AddKey("FMIN", 6, 6);
    kbRtype.AddKey("DBMAX",6, 6);
    kbRtype.AddKey("DBMIN",6, 6);
    kbRtype.AddKey("TIME", 6, 6);

    kbRtype2.Init(panelX + 64, panelY, 46, 20, 2, 1, TRUE, 1);
    kbRtype2.InitFrame(16, 26, 0, 0, 0);
    kbRtype2.InitColors( grey6, grey6);
    kbRtype2.InitKeyColors(grey4, grey4, col_lighted_border, grey6, grey5, col_pressed, grey3, grey7, grey8, black);
    kbRtype2.InitKeyFont("Tahoma", true, 0, 12, 0, grey0, grey0);
	kbRtype2.keypressed = -1;
    kbRtype2.AddKey("DUTY",  6, 6);
    kbRtype2.AddKey("BURST", 6, 6);
    kbRtype2.AddKey("PAUSE", 6, 6);
    kbRtype2.AddKey("BEGIN", 6, 6);
    kbRtype2.AddKey("END", 6, 6);
    kbRtype2.AddKey("OUTLEV",6, 6);

    kbRtype.frame.InitTitle(20, 6, 0, 15, 0, "Arial", grey1, grey1, true, "SETTINGS");
    DAA_SetLightedKeys(NULL);


    //TIME BASE
    panelX = 387;
    panelY = 341;

    frame3.Init(panelX , panelY, 190, 166, 16, grey3, panels);
    frame3.InitTitle(12, 8, 0, 15, 0, "Arial", grey1, grey1, true, "TIME BASE");

    dialer8.Init(panelX + 70 , panelY + 97, 40, 33, 4);
    dialer8.InitRange(.1, 100, 1, 1, 1, &scaleX);
    dialer8.InitScale(40, 320, 12);
    dialer8.InitScaleText(-10, -4, 10, 0, 11, 0, "Tahoma", grey1, grey1, true,
                          "500,200,100,  50,  20,  10,   5,   2,   1,   .5,   .2,   .1");
    dialer8.InitScaleValues("500,200,100,50,20,10,5,2,1,.5,.2,.1");
    dialer8.InitTitle(-20, 48, 0, 16, 0, "Arial", grey1, grey1, true, "mS / Div");
    dialer8.InitDual(26, 17, 5);
    dialer8.InitRangeDual(1, 2.5, 1, .001, .001, &regX);
    dialer8.InitScaleDual(30, 325, 1);

    dialer9.Init(panelX + 158, panelY + 30, 22, 14, 4);
    dialer9.InitRange(0, IN_CBUF_LEN, 2.5, .005, 1, &vispos); 
    dialer9.InitTitle(-18, 28, 0, 16, 0, "Arial", grey3, grey3, true, "Delay");

    dialer10.Init(panelX + 158, panelY + 117, 22, 14, 4);
    dialer10.InitRange(0, IN_CBUF_LEN, 2.5, .01, 1, &deltapos); 
    dialer10.InitTitle(-30, 28, 0, 16, 0, "Arial", grey3, grey3, true, "Delta time");

    key3.pressed = delayneg;
    key3.Init(panelX + 114, panelY + 27, 16, 14, 1, 0);
    key3.InitText("Neg", 0, -13, 0, 12, 0, grey0, grey0, false, "Tahoma");
    key3.InitColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);



    //CURSORS PANEL
    panelX = 581;
    panelY = 341;

    frame4.Init(panelX , panelY, 126, 166, 16, grey3, panels);
    frame4.InitTitle(12, 6, 0, 15, 0, "Arial", grey1, grey1, true, "METER");
   
    kbCurs.Init(panelX + 42, panelY + 26, 16, 14, 1, -1, TRUE, 1);
    kbCurs.InitFrame(0, 0, 0, 0, 0);
    kbCurs.InitColors(grey3, panels);
    kbCurs.InitKeyColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);
	kbCurs.InitKeyFont("Tahoma", false, 0, 12, 0, grey0, grey0);
    kbCurs.keypressed = curstype;
    kbCurs.AddKey("OFF",  -30, 3);
    kbCurs.AddKey("CH 1", -30, 3);
    kbCurs.AddKey("CH 2", -30, 3);
    kbCurs.AddKey("CURS", -30, 3);

    kbTime.Init(panelX + 100, panelY + 26, 14, 13, 1, -1, TRUE, 1);
    kbTime.InitFrame(0, 0, 0, 0, 0);
    kbTime.InitColors(grey3, panels);
    kbTime.InitKeyColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);
	kbTime.InitKeyFont("Tahoma", false, 0, 12, 0, grey0, grey0);
    kbTime.keypressed = timetype;
    kbTime.AddKey("TIME", -27, 2);
    kbTime.AddKey("FREQ", -30, 2);
    
    kbVolt.Init(panelX + 100, panelY + 58, 14, 13, 1, -1, TRUE, 1);
    kbVolt.InitFrame(0, 0, 0, 0, 0);
    kbVolt.InitColors(grey3, panels);
    kbVolt.InitKeyColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);
	kbVolt.InitKeyFont("Tahoma", false, 0, 12, 0, grey0, grey0);
    kbVolt.keypressed = volttype;
    kbVolt.AddKey("VOLT", -28, 2);
    kbVolt.AddKey("dB", -17, 2);
   
    dialer11.Init(panelX + 34, panelY + 118, 22, 14, 4);
    dialer11.InitRange(0, 1, 1.5, .0001, .0001, &curs1);
    dialer11.InitTitle(-24, 28, 0, 16, 0, "Arial", grey3, grey3, true, "Cursor 1");
    dialer12.Init(panelX + 94, panelY + 118, 22, 14, 4);
    dialer12.InitRange(0, 1, 1.5, .0001, .0001, &curs2);
    dialer12.InitTitle(-24, 28, 0, 16, 0, "Arial", grey3, grey3, true, "Cursor 2");


    //SPECTRUM PANEL
    panelX = 711;
    panelY = 341;
                                                          
    frame5.Init(panelX , panelY, 70, 166, 16, grey3, grey6);
    frame5.InitTitle(8, 6, 0, 14, 0, "Arial", grey1, grey1, true, "SPECTRUM");
  
    kbXlog.Init(panelX + 45, panelY + 26, 14, 13, 1, -1, TRUE, 1);
    kbXlog.InitFrame(0, 0, 0, 0, 0);
    kbXlog.InitColors(grey3, panels);
    kbXlog.InitKeyColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);
	kbXlog.InitKeyFont("Tahoma", false, 0, 12, 0, grey0, grey0);
    kbXlog.keypressed = xlogtype;
    kbXlog.AddKey("X LIN", -34, 2);
    kbXlog.AddKey("X LOG", -34, 2);
    
    kbYlog.Init(panelX + 45, panelY + 58, 14, 13, 1, -1, TRUE, 1);
    kbYlog.InitFrame(0, 0, 0, 0, 0);
    kbYlog.InitColors(grey3, panels);
    kbYlog.InitKeyColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);
	kbYlog.InitKeyFont("Tahoma", false, 0, 12, 0, grey0, grey0);
    kbYlog.keypressed = ylogtype;
    kbYlog.AddKey("Y LIN", -34, 2);
    kbYlog.AddKey("Y LOG", -34, 2);
    
    dialer13.Init(panelX + 36, panelY + 118, 22, 14, 4);
    dialer13.InitRange(.005, 1, 1, 1, .0001, &responsespeed);
    dialer13.InitTitle(-18, 28, 0, 16, 0, "Arial", grey3, grey3,true, "Speed");
    dialer13.InitScale(30, 330, 2);


	//STATUS-BAR PANEL                                         
    frame6.Init(-6, 516, 804, 20, 16, RGB(255,255,230), RGB(236,233,216));
    frame6.InitTitle(10, 1, 0, 14, 0, "Arial", grey1, grey1, true, "Ready");
}





void DAA_CreateInstrument(CDC* pDC)
{
    // ------------------------------------------------------------ colors
    black = 0;
    panels = RGB(195,195,195);
    wavepanel = RGB(170,190,110);
    col_pressed = RGB(255,180,100);
	col_lighted_border = RGB(110,110,255);
	grey0 = RGB(20,20,20);
	grey1 = RGB(40,40,40);
	grey2 = RGB(60,60,60);
    grey3 = RGB(80,80,80);
    grey4 = RGB(110,110,100); 
    grey5 = RGB(140,140,140);  
    grey6 = RGB(180,180,180); 
    grey7 = RGB(200,200,200); 
    grey8 = RGB(230,230,230);
	grey9 = RGB(240,240,240);
    white = RGB(255,255,255);
    dback = RGB(30,90,120);
    trace = RGB(240,255,230);
    dgrid = RGB(20,60,90);

    if (pDC->GetDeviceCaps(BITSPIXEL) <= 8)
    {
        ClipCursor(NULL);
        theApp.m_pMainWnd->MessageBox("DAA can run in this video mode but HiColor is better",
                                    "Warning from DAA", MB_SYSTEMMODAL);

        panels = pDC->GetNearestColor(panels);
        wavepanel = panels;
        col_pressed = pDC->GetNearestColor(col_pressed);
		grey0 = pDC->GetNearestColor(grey0);
        grey1 = pDC->GetNearestColor(grey1);
        grey2 = pDC->GetNearestColor(grey2);
        grey3 = pDC->GetNearestColor(grey3);
        grey4 = pDC->GetNearestColor(grey4);
        grey5 = pDC->GetNearestColor(grey5);
		grey6 = pDC->GetNearestColor(grey6);
		grey7 = pDC->GetNearestColor(grey7);
        grey8 = pDC->GetNearestColor(grey8);
		grey9 = pDC->GetNearestColor(grey9);
        //white = pDC->GetNearestColor(white);
        //dback = pDC->GetNearestColor(dback);
    }

	// ------------------------------------------------------------ init all the controls
    DAA_InitObjects();


    // ------------------------------------------------------------ memory DC
    MemBmp.CreateCompatibleBitmap(pDC, CLIENT_X, CLIENT_Y);
    MemDC.CreateCompatibleDC(pDC);
    MemDC.SelectObject(MemBmp);

	// ------------------------------------------------------------ background ( border ) color
	MemDC.FillSolidRect(0, 0, CLIENT_X, CLIENT_Y, RGB(160,160,160));

    // ------------------------------------------------------------ draw all to memory dc
    daaFrame.Draw(&MemDC);

    frame1.Draw(&MemDC);
    dialer1.Draw(&MemDC);
    dialer2.Draw(&MemDC);
    dialer3.Draw(&MemDC);
	keysamp.Draw(&MemDC);
    keycal.Draw(&MemDC); 
    ledcal.Draw(&MemDC);

    kbInOnOff.Draw(&MemDC);
    kbOutOnOff.Draw(&MemDC);

    display.Draw(&MemDC);

    frame2.Draw(&MemDC);
    kbChan.Draw(&MemDC);
    kbGnd1.Draw(&MemDC);
    kbGnd2.Draw(&MemDC);
    dialer4.Draw(&MemDC);
    dialer5.Draw(&MemDC);
    dialer6.Draw(&MemDC);
    dialer7.Draw(&MemDC);

    kbTrig.Draw(&MemDC);
    key1.Draw(&MemDC);
    key2.Draw(&MemDC);
    ledtrig.Draw(&MemDC);
    dialerTrig.Draw(&MemDC);
    kbChtrig.Draw(&MemDC);

    kbWtype.Draw(&MemDC);
    kbAtype.Draw(&MemDC);

    kbRtype.Draw(&MemDC);
    kbRtype2.Draw(&MemDC);
    dialer.Draw(&MemDC);
    DAA_DrawIndicator(&MemDC, regulationtype);

    frame3.Draw(&MemDC);
    dialer8.Draw(&MemDC);
    dialer9.Draw(&MemDC);
    dialer10.Draw(&MemDC);
	key3.Draw(&MemDC);

    frame4.Draw(&MemDC);
    kbCurs.Draw(&MemDC);
    kbTime.Draw(&MemDC);
    kbVolt.Draw(&MemDC);
    dialer11.Draw(&MemDC);
    dialer12.Draw(&MemDC);

    frame5.Draw(&MemDC);
    kbXlog.Draw(&MemDC);
    kbYlog.Draw(&MemDC);
    dialer13.Draw(&MemDC);

	frame6.Draw(&MemDC);

    display.DisplayWave(&MemDC);

	// ------------------------------------------------------------ copy MemDC to client pDC 
	pDC->BitBlt(0, 0, CLIENT_X, CLIENT_Y, &MemDC, 0, 0, SRCCOPY);
}




void DAA_Draw(CDC* pDC)
{   
    //CPalette* pPaletteOld = pDC->SelectPalette( &palette, TRUE );
	//pDC->RealizePalette();

    kbInOnOff.Update(&MemDC);
    kbOutOnOff.Update(&MemDC);
    kbChan.Update(&MemDC);
    kbGnd1.Update(&MemDC);
    kbGnd2.Update(&MemDC);
    kbChtrig.Update(&MemDC);
    kbTrig.Update(&MemDC);
    kbAtype.Update(&MemDC);
    kbWtype.Update(&MemDC);
    kbGnd1.Update(&MemDC);
    kbGnd2.Update(&MemDC);
    kbCurs.Update(&MemDC);
    kbTime.Update(&MemDC);
    kbVolt.Update(&MemDC);
    kbXlog.Update(&MemDC);
    kbYlog.Update(&MemDC);
    kbRtype.Update(&MemDC);
    kbRtype2.Update(&MemDC); 
    key1.Draw(&MemDC);
    key2.Draw(&MemDC);
	keysamp.Draw(&MemDC);
    keycal.Draw(&MemDC);
    DAA_DrawUpdatedDialers(&MemDC);
    DAA_DrawIndicator(&MemDC, regulationtype);
    display.DisplayWave(&MemDC); 

	// ------------------------------------------------------------ copy MemDC to client pDC 
    pDC->BitBlt(0, 0, CLIENT_X, CLIENT_Y, &MemDC, 0, 0, SRCCOPY);

    //pDC->SelectPalette(pPaletteOld, FALSE);
}



void DAA_LButtonDown(CDC* pDC, CPoint point)
{    
    RECT rect;
    CWnd* pWnd = pDC->GetWindow();
    pWnd->GetClientRect(&rect);
    pWnd->ClientToScreen(&rect);
    ClipCursor(&rect);
    
    if (dialer.ClickInside(pDC, point))
	{
		if (indicator.editing)
		{
			dialer.SetValue(atof(indicator.strValue));
			indicator.editing = false;
		}
		control = 1;
	}
    else if (dialer1.ClickInside(pDC, point)) control = 2;
    else if (dialer2.ClickInside(pDC, point)) control = 3;
    else if (dialer3.ClickInside(pDC, point)) control = 4;
    else if (dialer4.ClickInside(pDC, point)) control = 5;
    else if (dialer5.ClickInside(pDC, point)) control = 6;
    else if (dialer6.ClickInside(pDC, point)) control = 7;
    else if (dialer7.ClickInside(pDC, point)) control = 8;
    else if (dialer8.ClickInside(pDC, point)) control = 9;
    else if (dialer9.ClickInside(pDC, point)) control = 10;
    else if (dialer10.ClickInside(pDC, point)) control = 11;
    else if (dialer11.ClickInside(pDC, point)) control = 12;
    else if (dialer12.ClickInside(pDC, point)) control = 13;
    else if (dialer13.ClickInside(pDC, point)) control = 14;
    else if (dialerTrig.ClickInside(pDC, point)) control = 15;
    //if (control) ShowCursor(FALSE);

    else if (kbWtype.ClickInside(pDC, point))
    {
        wavetype = kbWtype.keypressed;
        DAA_FillWaveTable(wavetype);
        display.DisplayWave(pDC);  
        DAA_SetLightedKeys(pDC);
        ResetSweep(TRUE);
        calibratedResponse = FALSE;
        ledcal.Update(pDC, 0);
    }
    else if (kbAtype.ClickInside(pDC, point))
    {
        analisistype = kbAtype.keypressed;
		
		// ----------------------------------- SWEEP, SPECTRUM & PULSE can work only in mono mode
		if (analisistype >= ANTYPE_SPECTR && inputState > 1)
		{
			kbInOnOff.PressKey(pDC, 1);
            DAA_InputOn(1);
		}
		// -------------------------------------------------------------------------------------

        DAA_SetLightedKeys(pDC);    
        if (analisistype == ANTYPE_SPECTR && spectrum3D && spectrumDisplay) display.Clear();
        if (analisistype >= ANTYPE_SPECTR) ResetResponseTab();
        display.CreateGrid();
        ResetSweep(TRUE);
        calibratedResponse = FALSE;
        ledcal.Update(pDC, 0);
        DAA_AdjustBuffers();  
    }
    else if (kbRtype.ClickInside(pDC, point))
    {
		indicator.editing = false;
        kbRtype2.ReleaseAllKeys(pDC);
        regulationtype = kbRtype.keypressed;
        DAA_SetRegulationType(regulationtype);
        dialer.Update(pDC);
        DAA_DrawIndicator(pDC, regulationtype);
    }
    else if (kbRtype2.ClickInside(pDC, point))
    {
		indicator.editing = false;
        kbRtype.ReleaseAllKeys(pDC);
        regulationtype = kbRtype2.keypressed + 6;
        DAA_SetRegulationType(regulationtype);
        dialer.Update(pDC);
        DAA_DrawIndicator(pDC, regulationtype);
    }
    else if (kbTrig.ClickInside(pDC, point))
    {
        trigtype = kbTrig.keypressed;
        DAA_SetTrigType(trigtype);
        dialerTrig.Update(pDC);
    }
    else if (kbChan.ClickInside(pDC, point)) selectCH = kbChan.keypressed;
    else if (kbGnd1.ClickInside(pDC, point)) gnd1 = kbGnd1.keypressed;
    else if (kbGnd2.ClickInside(pDC, point)) gnd2 = kbGnd2.keypressed;
    else if (kbChtrig.ClickInside(pDC, point)) trigCH = kbChtrig.keypressed;
    else if (key1.ClickInside(pDC, point)) trigslope = key1.pressed;
    else if (key2.ClickInside(pDC, point)) trigburst = key2.pressed;
	else if (key3.ClickInside(pDC, point)) delayneg = key3.pressed;
	else if (keysamp.ClickInside(pDC, point))
	{
		if (spectrumDisplay)
		{
			spectrumDisplay = FALSE;
			calibratedResponse = FALSE;
			ledcal.Update(pDC, 0); 
		}
		else
		{
			spectrumDisplay = TRUE;
			if (analisistype == ANTYPE_SPECTR && spectrum3D) display.Clear();
		}
		display.CreateGrid();
	}

    else if (keycal.ClickInside(pDC, point))
    {
        if (analisistype >= ANTYPE_SPECTR && spectrumDisplay)
        {
            if (calibratedResponse)
            {            
                for (int i = 0; i <= dispx; i++) calibrateTab[i] = 1; 
                ResetSweep(TRUE);
                calibratedResponse = FALSE;
                ledcal.Update(pDC, 0);
            }
            else
            {           
                double midvalue = 0;
                for (int i = 0; i < dispx / 2; i++)
                {
                    if (responseTab[dispx / 2 + i] > 0)
                    {
                        midvalue = responseTab[dispx / 2 + i];
                        break;
                    }
                    if (responseTab[dispx / 2 - i] > 0)
                    {
                        midvalue = responseTab[dispx / 2 - i];
                        break;
                    }
                }
                if (midvalue > 0)
                {
                    for (int i = 0; i <= dispx; i++)
                    {
                        if (responseTab[i] > 0) calibrateTab[i] = midvalue / responseTab[i];
                    }
                    ResetSweep(TRUE);
                    calibratedResponse = TRUE;
                    ledcal.Update(pDC, 2);
                }
            }
            keycal.PressKey(pDC, 0);
        }
        else
        {
            // AUTO CALIBRATION
            if (inputState)
            {     
                int oldcurs = curstype;
             
                // TEST 
                int sum;
                curstype = 1;
                vmax = -99999;
                vmin = 99999;
                InitTime(); while (GetTime() < 100000);
                sum = vmax - vmin;
                if (inputState == 2)
                {
                    curstype = 2;
                    vmax = vmin = 0;
                    InitTime(); while (GetTime() < 100000);
                    if (vmax - vmin > sum) sum = (vmax - vmin);
                }

                // ONLY IF SIGNAL < 3 mVpp
                if (sum < 100)
                {    
                    calY1 = 0;
                    curstype = 1;
                    InitTime(); while (GetTime() < 50000);
                    int midv = 0;    
                    vmax = -99999;
                    vmin = 99999;
                    for (int i = 0; i < 5; i++)
                    {
                        ledcal.Update(pDC, 1);
                        InitTime(); while (GetTime() < 100000);               
                        midv += (vmax + vmin) / 2;
                        ledcal.Update(pDC, 0);
                        InitTime(); while (GetTime() < 100000);              
                        midv += (vmax + vmin) / 2;
                    }
                    calY1 = -midv / 10;

                    if (inputState == 2)
                    {
                        calY2 = 0;
                        curstype = 2;
                        InitTime(); while (GetTime() < 50000);
                        midv = 0;   
                        vmax = -99999;
                        vmin = 99999;
                        for (int i = 0; i < 5; i++)
                        {
                            ledcal.Update(pDC, 2);
                            InitTime(); while (GetTime() < 100000);                 
                            midv += (vmax + vmin) / 2;
                            ledcal.Update(pDC, 0);
                            InitTime(); while (GetTime() < 100000);                         
                            midv += (vmax + vmin) / 2;
                        }
                        calY2 = -midv / 10;
                    }

                    InitTime();
                    WriteIni();
                    while (GetTime() < 200000);
                }

                curstype = oldcurs;
                ledcal.Update(pDC, 0);        
            }
            keycal.PressKey(pDC, 0);
        }
    }
    else if (kbInOnOff.ClickInside(pDC, point))
    {
        if (!DAA_InputOn(kbInOnOff.keypressed)) kbInOnOff.PressKey(pDC, 0);

        if (analisistype >= ANTYPE_SPECTR) 
        {
            ResetSweep(TRUE);
            calibratedResponse = FALSE;
            ledcal.Update(pDC, 0);

			// ----------------------------------- SWEEP, SPECTRUM & PULSE can work only in mono mode
			if (inputState > 1)
			{
				kbInOnOff.PressKey(pDC, 1);
				DAA_InputOn(1);
			}
			// -------------------------------------------------------------------------------------

        }
    }
    else if (kbOutOnOff.ClickInside(pDC, point))
    {
        if (!DAA_OutputOn(kbOutOnOff.keypressed, TRUE)) kbOutOnOff.PressKey(pDC, 0);
        if (analisistype >= ANTYPE_SPECTR)
        {
            ResetSweep(TRUE);
            calibratedResponse = FALSE;
            ledcal.Update(pDC, 0);
        }
        if (!outputState) DAA_AdjustBuffers();
    }
    else if (kbCurs.ClickInside(pDC, point)) curstype = kbCurs.keypressed;
    else if (kbTime.ClickInside(pDC, point)) timetype = kbTime.keypressed;
    else if (kbVolt.ClickInside(pDC, point)) volttype = kbVolt.keypressed;
    else if (kbXlog.ClickInside(pDC, point))
    {
        xlogtype = kbXlog.keypressed;
        if (analisistype >= ANTYPE_SPECTR) display.CreateGrid();
        ResetSweep(TRUE);
        calibratedResponse = FALSE;
        ledcal.Update(pDC, 0);
    }
    else if (kbYlog.ClickInside(pDC, point))
    {
        ylogtype = kbYlog.keypressed;
        if (analisistype >= ANTYPE_SPECTR) display.CreateGrid();
    }

	else if (indicator.ClickInside(pDC, point))
    {
		if (!indicator.editing)
		{
			double value;
			value = DAA_GetIndicatorValue(regulationtype);
			CString str;
			str.Format("%.2f", value);
			indicator.strValue = str;
			indicator.editpos = str.GetLength()+1;
			indicator.textselected = true;

			indicator.editing = true;
			DAA_DrawIndicator(pDC, regulationtype);
		}
    }
}





void DAA_AdjustBuffers()
{
    if (inputState)
    {      
        int oldstate = inputState;
        DAA_InputOff();
        DAA_InputOn(oldstate);
    }
    
    if (outputState)
    {   
        DAA_OutputOff();
        DAA_OutputOn(1, FALSE);
    }
}




void DAA_SetLightedKeys(CDC* pDC)
{
    kbRtype.UnlightAllKeys(pDC);
    kbRtype2.UnlightAllKeys(pDC);

    switch (analisistype)
    {
        case ANTYPE_WAVE: 
            kbRtype.LightKey(pDC, 0);
            kbRtype2.LightKey(pDC, 5);
			break;  

        case ANTYPE_BURST: 
            kbRtype.LightKey(pDC, 0);
            kbRtype2.LightKey(pDC, 1);
            kbRtype2.LightKey(pDC, 2);
            kbRtype2.LightKey(pDC, 5);
            burstcounter = 0;
            burstflag = TRUE;
			break;

		case ANTYPE_SPECTR:
            kbRtype.LightKey(pDC, 0);
            kbRtype.LightKey(pDC, 1);
            kbRtype.LightKey(pDC, 2);
            kbRtype.LightKey(pDC, 3);
            kbRtype.LightKey(pDC, 4);
            kbRtype2.LightKey(pDC, 5); 
			break;
        
		case ANTYPE_SWEEP:
            kbRtype.LightKey(pDC, 1);
            kbRtype.LightKey(pDC, 2);
            kbRtype.LightKey(pDC, 3);
            kbRtype.LightKey(pDC, 4);
            kbRtype.LightKey(pDC, 5);
            kbRtype2.LightKey(pDC, 5);
			break;

        case ANTYPE_FASTSW:
			kbRtype.LightKey(pDC, 1);
            kbRtype.LightKey(pDC, 2);
            kbRtype.LightKey(pDC, 3);
            kbRtype.LightKey(pDC, 4);
            kbRtype2.LightKey(pDC, 3);
            kbRtype2.LightKey(pDC, 5);
			break;

        case ANTYPE_PULSE:
            kbRtype.LightKey(pDC, 1);
            kbRtype.LightKey(pDC, 2);
            kbRtype.LightKey(pDC, 3);
            kbRtype.LightKey(pDC, 4);
            kbRtype2.LightKey(pDC, 3);
            kbRtype2.LightKey(pDC, 4);
            kbRtype2.LightKey(pDC, 5);
			break;
    }
    if (wavetype == WAVETYPE_SQUARE && (analisistype == ANTYPE_WAVE ||
										analisistype == ANTYPE_BURST || 
										analisistype == ANTYPE_SWEEP))    kbRtype2.LightKey(pDC, 0);

}

void DAA_SetRegulationType(int type)
{    
    switch (type)
    {
        case 0:
            dialer.InitRange(1, 22000, 3, .02, .1, &freq);
			break;
        case 1:
            dialer.InitRange(1, 22000, 3, .02, .1, &freqmax);
			break;
        case 2:
            dialer.InitRange(1, 22000, 3, .02, .1, &freqmin);
			break;
        case 3:
            dialer.InitRange(-90, 10, 1.2, .05, .1, &dbmax);
			break;
        case 4:
            dialer.InitRange(-120, 10, 1.2, .05, .1, &dbmin);
			break;
        case 5:
            dialer.InitRange(.5, 99, 1.2, .1, .5, &sweeptime);
			break;
        case 6:
            dialer.InitRange(10, 90, 1.3, .02, .1, &duty);     
			break;
        case 7:
            dialer.InitRange(1, 999, 1.3, .1, 1, &burstcycles);
			break;
        case 8:
            dialer.InitRange(1, 999, 1.3, .1, 1, &pausecycles);
			break;
        case 9:
            dialer.InitRange(-50, 50, 1.9, .01, .01, &start_sampling_ms);
			break;
		case 10:
            dialer.InitRange(10, out_pulse_millisec, 1.9, .01, .01, &sampling_ms);
			break;
        case 11:
            dialer.InitRange(-20, 0, 1.2, .05, .1, &outlevel);
			break;
    }
}


void DAA_SetTrigType(int type)
{    
    switch (type)
    {
        case 0:
            dialerTrig.InitRange(-1, 1, 1, 1, .000001, &trigvoid);
        break;
        case 1:
            dialerTrig.InitRange(0, 1, 1, 1, .000001, &trigpos);
        break;
        case 2:
            dialerTrig.InitRange(-1, 1, 1, 1, .000001, &triglev);
        break;
        case 3:
            dialerTrig.InitRange(0, 1, 1, 1, .000001, &trigist);
        break;
        case 4:
            dialerTrig.InitRange(0, 1, 1, 1, .000001, &trigstab);
        break;
    }
    dialerTrig.InitScale(40, 320, 2);
}

void DAA_DrawIndicator(CDC* pDC, int type)
{
    switch (type)
    {
        case 0: indicator.Draw(pDC, freq, 0); break;
        case 1: indicator.Draw(pDC, freqmax, 1); break;
        case 2: indicator.Draw(pDC, freqmin, 2); break;
        case 3: indicator.Draw(pDC, dbmax, 3); break;
        case 4: indicator.Draw(pDC, dbmin, 4); break;
        case 5: indicator.Draw(pDC, sweeptime, 5); break;
        
        case 6: indicator.Draw(pDC, duty, 6); break;
        case 7: indicator.Draw(pDC, burstcycles, 7); break;
        case 8: indicator.Draw(pDC, pausecycles, 8); break;
        case 9: indicator.Draw(pDC, start_sampling_ms, 9); break;
        case 10: indicator.Draw(pDC, sampling_ms, 10); break;    
        case 11: indicator.Draw(pDC, outlevel, 11); break;
    }
}


double DAA_GetIndicatorValue(int type)
{
    switch (type)
    {
        case 0: return freq; break;
        case 1: return freqmax; break;
        case 2: return freqmin; break;
        case 3: return dbmax; break;
        case 4: return dbmin; break;
        case 5: return sweeptime; break;
        
        case 6: return duty; break;
        case 7: return burstcycles; break;
        case 8: return pausecycles; break;
        case 9: return start_sampling_ms; break;
        case 10: return sampling_ms; break;    
        case 11: return outlevel; break;
    }
	return 0;
}




void DAA_LButtonUp(CDC* pDC, CPoint point)
{  
	pDC; point;
	//
    //if (control) ShowCursor(TRUE);
    control = 0;
    ClipCursor(NULL);
}


void DAA_MouseMove(CDC* pDC, CPoint point)
{
    switch (control)
    {
        case 0:
            {
                helpindex = 0;
                
                if (dialer1.Inside(point)) helpindex = 1;
                else if (dialer2.Inside(point)) helpindex = 2;
                else if (dialer3.Inside(point)) helpindex = 3;
                else if (dialer4.Inside(point))
                {
                    if (dialer4.Inside(point) == 1) helpindex = 4;
                    else helpindex = 5;
                }
                else if (dialer5.Inside(point))
                {
                    if (dialer5.Inside(point) == 1) helpindex = 6;
                    else helpindex = 7;
                }
                else if (dialer6.Inside(point)) helpindex = 8;
                else if (dialer7.Inside(point)) helpindex = 9;
                else if (dialer8.Inside(point))
                {
                    if (dialer8.Inside(point) == 1) helpindex = 10;
                    else helpindex = 11;
                }
                else if (dialer9.Inside(point)) helpindex = 12;
                else if (dialer10.Inside(point)) helpindex = 13;
                else if (dialer11.Inside(point)) helpindex = 14;
                else if (dialer12.Inside(point)) helpindex = 15;
                else if (dialer13.Inside(point)) helpindex = 16;
                
                else if (key1.Inside(point)) helpindex = 17;
                else if (key2.Inside(point)) helpindex = 18;
				else if (keysamp.Inside(point)) helpindex = 201;
                else if (keycal.Inside(point)) helpindex = 19;

                else if (dialer.Inside(point)) helpindex = regulationtype + 20;
                else if (indicator.Inside(point)) helpindex = regulationtype + 20;
                else if (dialerTrig.Inside(point)) helpindex = trigtype + 60;
                else if (kbRtype.Inside(point)) helpindex = kbRtype.PointedKey(point) + 20;
                else if (kbRtype2.Inside(point)) helpindex = kbRtype2.PointedKey(point) + 26;
                else if (kbAtype.Inside(point)) helpindex = kbAtype.PointedKey(point) + 40;
                else if (kbWtype.Inside(point)) helpindex = kbWtype.PointedKey(point) + 50;
                else if (kbTrig.Inside(point)) helpindex = kbTrig.PointedKey(point) + 60;
                else if (kbChan.Inside(point)) helpindex = kbChan.PointedKey(point) + 70;
                else if (kbGnd1.Inside(point)) helpindex = kbGnd1.PointedKey(point) + 80;
                else if (kbGnd2.Inside(point)) helpindex = kbGnd2.PointedKey(point) + 90;
                else if (kbChtrig.Inside(point)) helpindex = kbChtrig.PointedKey(point) + 100;
                else if (kbInOnOff.Inside(point)) helpindex = kbInOnOff.PointedKey(point) + 110;
                else if (kbOutOnOff.Inside(point)) helpindex = kbOutOnOff.PointedKey(point) + 115;
                else if (kbCurs.Inside(point)) helpindex = kbCurs.PointedKey(point) + 120;
                else if (kbTime.Inside(point)) helpindex = kbTime.PointedKey(point) + 130;
                else if (kbVolt.Inside(point)) helpindex = kbVolt.PointedKey(point) + 140;
                else if (kbXlog.Inside(point)) helpindex = kbXlog.PointedKey(point) + 150;
                else if (kbYlog.Inside(point)) helpindex = kbYlog.PointedKey(point) + 160;

                else helpindex = 0;

                if (helpindex == oldhelpindex) break;

                oldhelpindex = helpindex;
                CString help;
                switch (helpindex)
                {
                    case 0: help = "Ready"; break;
                    case 1: help = "Grid lightning"; break;
                    case 2: help = "Readout intensity"; break;
                    case 3: help = "Trace intensity"; break;
                    case 4: help = "CH1 - Volts per division  ( Y-scale )"; break;
                    case 5: help = "CH1 - Volts per division  ( regulation )"; break;
                    case 6: help = "CH2 - Volts per division  ( Y-scale )"; break;
                    case 7: help = "CH2 - Volts per division  ( regulation )"; break;
                    case 8: help = "CH1 - Vertical position"; break;
                    case 9: help = "CH2 - Vertical position"; break;
                    case 10: help = "Time per division  ( X-scale )"; break;
                    case 11: help = "Time per division  ( regulation )"; break;
                    case 12: help = "Delay time  ( only when input is off )"; break;
                    case 13: help = "Delta time  ( from channel 1 and channel 2 )"; break;
                    case 14: help = "Cursor 1 position"; break;
                    case 15: help = "Cursor 2 position"; break;
                    case 16: help = "Response speed for SPECTRUM & PULSE"; break;
                 
                    case 17: help = "Trigger slope  ( press for negative slope )"; break;
                    case 18: help = "Trigger for burst waveforms"; break;

					case 201: help = "View samples for SPECTRUM, SWEEP & PULSE"; break;
                    
                    case 19:
                        if (analisistype < ANTYPE_SPECTR)
                        {
                            help = "Calibrate for WAVE  & BURST  ( use with stereo input & recording sliders all down )";
                        }
                        else
                        {
                            help = "Calibrate for SPECTRUM SWEEP & PULSE  ( use to set a 'reference' flat frequency response )";
                        }
                        break;

                    case 20: help = "Waveform frequency"; break;
                    case 21: help = "Maximum frequency for SPECTRUM SWEEP & PULSE X-scale"; break;
                    case 22: help = "Minimum frequency for SPECTRUM SWEEP & PULSE X-scale"; break;
                    case 23: help = "Maximum voltage for SPECTRUM SWEEP & PULSE Y-scale"; break;
                    case 24: help = "Minimum voltage for SPECTRUM SWEEP & PULSE Y-scale"; break;
                    case 25: help = "Sweep time"; break;
            
                    case 26: help = "Duty cycle  ( only for square wave )"; break;
                    case 27: help = "Burst body  ( number of cycles )"; break;
                    case 28: help = "Burst pause  ( number of cycles )"; break;                    
                    case 29: help = "Begin sampling  ( distance )"; break;
                    case 30: help = "End sampling  ( distance )"; break;
                    case 31: help = "Output level"; break;
                    
                    case 40: help = "Simple wave generator and scope"; break;
                    case 41: help = "Burst generator and scope"; break;
                    case 42: help = "Sweep generator with frequency response analyser"; break;
                    case 43: help = "Wave generator with Fourier spectrum analisis"; break;
                    case 44: help = "Pulse generator with Fourier spectrum analisis  ( optimized for low frequencies )"; break;
                    case 45: help = "Pulse generator with Fourier spectrum analisis  ( optimized for high frequencies )"; break;

                    case 50: help = "Sinusoidal wave"; break;
                    case 51: help = "Triangular wave"; break;
                    case 52: help = "Positive sawtoot"; break;
                    case 53: help = "Negative sawtoot"; break;
                    case 54: help = "Square wave"; break;
                    case 55: help = "White noise"; break;

                    case 60: help = "Trigger disabled"; break;
                    case 61: help = "Trigger position on X-axis"; break;
                    case 62: help = "Trigger level"; break;
                    case 63: help = "Trigger noise  ( increase if waveform is noisy )"; break;
                    case 64: help = "Trigger stability  ( regulate for best triggering )"; break;
                    
                    case 70: help = "Channel 1 only"; break;
                    case 71: help = "Channel 2 only"; break;
                    case 72: help = "Both channels"; break;
                    case 73: help = "Add channels  ( Y is CH1 + CH2 )"; break;
                    case 74: help = "Sub channels  ( Y is CH1 - CH2 )"; break;
                    case 75: help = "XY display  ( CH1 is X / CH2 is Y )"; break;
                    
                    case 80: help = "Channel 1  AC coupled"; break;
                    case 81: help = "Channel 1  DC coupled"; break;
                    case 82: help = "Channel 1 grounded"; break;
                   
                    case 90: help = "Channel 2  AC coupled"; break;
                    case 91: help = "Channel 2  DC coupled"; break;
                    case 92: help = "Channel 2 grounded"; break;

                    case 100: help = "Trigger on channel 1"; break;
                    case 101: help = "Trigger on channel 2"; break;

                    case 110: help = "Input disabled"; break;
                    case 111: help = "Input for channel 1 only"; break;
                    case 112: help = "Input for channels 1 and 2"; break;
                    case 115: help = "Output disabled"; break;
                    case 116: help = "Output enabled"; break;
                        
                    case 120: help = "All measurations off"; break;
                    case 121: help = "Continuous frequency-meter and volt-meter on channel 1"; break;
                    case 122: help = "Continuous frequency-meter and volt-meter on channel 2"; break;
                    case 123: help = "Distance and time between cursors"; break;

                    case 130: help = "Display measured time"; break;
                    case 131: help = "Display measured frequency"; break;

                    case 140: help = "Display measured voltage"; break;
                    case 141: help = "Display measured decibels"; break;

                    case 150: help = "X scale linear for SWEEP SPECTRUM & PULSE"; break;
                    case 151: help = "X scale logarithmic for SWEEP SPECTRUM & PULSE"; break;
                    case 160: help = "Y scale linear for SWEEP SPECTRUM & PULSE"; break;
                    case 161: help = "Y scale logarithmic for SWEEP SPECTRUM & PULSE"; break;

                    default: help = "-----";
                } 
				frame6.SetText(pDC, help);
            }
        break;
        case 1:
            dialer.Rotation(pDC, point);              
            if (regulationtype == 1 && freqmax < freqmin + .1) dialer.SetValue(freqmin + .1);
            if (regulationtype == 2 && freqmin > freqmax - .1) dialer.SetValue(freqmax - .1);  
            if (regulationtype == 3 && dbmax < dbmin + 1) dialer.SetValue(dbmin + 1);
            if (regulationtype == 4 && dbmin > dbmax - 1) dialer.SetValue(dbmax - 1); 
            if (regulationtype == 6 && wavetype == WAVETYPE_SQUARE) DAA_FillWaveTable(wavetype);     
            if (regulationtype == 11) DAA_FillWaveTable(wavetype);

			if (regulationtype == 9)
            {
                CString s;
				s.Format("Start sampling correction: %5.2f mS", start_sampling_ms);
				frame6.SetText(pDC, s);
            }

            if (regulationtype == 10)
            {
                CString s;
				double ms = sampling_ms;
                double m = 0.341 * ms;
                int hz = int(1000 / ms);
				s.Format("Sampling time:%5.0f mS  -  Lower bandpass: %i Hz  -  Sound travels: %5.1f m", ms, hz, m);
				frame6.SetText(pDC, s);
            }
            
            if (analisistype >= ANTYPE_SPECTR)
            {              
                if (regulationtype == 1 || regulationtype == 2
                    || regulationtype == 5)
                {
                    ResetSweep(TRUE);
                    calibratedResponse = FALSE;
                    ledcal.Update(pDC, 0);
                }
          
                if (regulationtype == 1 || regulationtype == 2 ||
                    regulationtype == 3 || regulationtype == 4) display.CreateGrid();     
            }

            DAA_DrawIndicator(pDC, regulationtype);

        break;
        case 2:
            dialer1.Rotation(pDC, point);
            display.CreateGrid();
        break;
        case 3:
            dialer2.Rotation(pDC, point);
            if (analisistype >= ANTYPE_SPECTR) display.CreateGrid();
        break;
        case 4:
            dialer3.Rotation(pDC, point);
        break; 
        case 5:
            dialer4.Rotation(pDC, point);
        break; 
        case 6:
            dialer5.Rotation(pDC, point);
        break; 
        case 7:
            dialer6.Rotation(pDC, point);
        break; 
        case 8:
            dialer7.Rotation(pDC, point);
        break; 
        case 9:
            dialer8.Rotation(pDC, point);
        break; 
        case 10:
            dialer9.Rotation(pDC, point);
        break;
        case 11:
            dialer10.Rotation(pDC, point);
        break;
        case 12:
            dialer11.Rotation(pDC, point);
        break;
        case 13:
            dialer12.Rotation(pDC, point);
        break;
        case 14:
            dialer13.Rotation(pDC, point);
        break;
        case 15:
            dialerTrig.Rotation(pDC, point);
        break; 
    }
    if (control) display.DisplayWave(pDC);  
}

void DAA_KeyDown(CDC* pDC, UINT nChar)
{
	if 	(indicator.editing)
	{
		switch (nChar)
		{
			case 48: indicator.AddDigit(pDC, "0"); break;
			case 49: indicator.AddDigit(pDC, "1"); break;
			case 50: indicator.AddDigit(pDC, "2"); break;
			case 51: indicator.AddDigit(pDC, "3"); break;
			case 52: indicator.AddDigit(pDC, "4"); break;
			case 53: indicator.AddDigit(pDC, "5"); break;
			case 54: indicator.AddDigit(pDC, "6"); break;
			case 55: indicator.AddDigit(pDC, "7"); break;
			case 56: indicator.AddDigit(pDC, "8"); break;
			case 57: indicator.AddDigit(pDC, "9"); break;
			case 188: case 190: indicator.AddDigit(pDC, "."); break;
			case 189: case 109: indicator.AddDigit(pDC, "-"); break;

			case VK_LEFT: indicator.KeyLeft(pDC); break;
			case VK_RIGHT: indicator.KeyRight(pDC); break;
			case VK_BACK: indicator.Backspace(pDC); break;
			case VK_DELETE: indicator.Delete(pDC); break;

			case VK_ESCAPE:
				indicator.editing = false;
				DAA_DrawIndicator(pDC, regulationtype);
				break;
				
			case VK_RETURN:
				dialer.SetValue(atof(indicator.strValue));
				indicator.editing = false;
				DAA_DrawIndicator(pDC, regulationtype);
				display.CreateGrid();
				DAA_FillWaveTable(wavetype);
				break;

			default:
		    	return;
		}
	}
}

void DAA_Save(CArchive& ar)
{
    CString str("DAA_REG 1.1 ");
    ar.Write(str, 12);

    ar.Write(&freq,sizeof(freq));
    ar.Write(&freqmin,sizeof(freqmin));
    ar.Write(&freqmax,sizeof(freqmax));
    ar.Write(&sweeptime,sizeof(sweeptime));
    ar.Write(&start_sampling_ms,sizeof(start_sampling_ms));
    ar.Write(&sampling_ms,sizeof(sampling_ms));

    ar.Write(&duty,sizeof(duty));
    ar.Write(&burstcycles,sizeof(burstcycles));
    ar.Write(&pausecycles,sizeof(pausecycles));
    ar.Write(&dbmin,sizeof(dbmin));
    ar.Write(&dbmax,sizeof(dbmax));
    ar.Write(&outlevel,sizeof(outlevel));

    ar.Write(&scaleX,sizeof(scaleX));
    ar.Write(&scaleY1,sizeof(scaleY1));
    ar.Write(&scaleY2,sizeof(scaleY2));
    ar.Write(&regX,sizeof(regX));
    ar.Write(&regY1,sizeof(regY1));
    ar.Write(&regY2,sizeof(regY2));

    ar.Write(&posY1,sizeof(posY1));
    ar.Write(&posY2,sizeof(posY2));

    ar.Write(&selectCH,sizeof(selectCH));
    ar.Write(&gnd1,sizeof(gnd1));
    ar.Write(&gnd2,sizeof(gnd2));
    ar.Write(&trigCH,sizeof(trigCH));
    ar.Write(&inputState,sizeof(inputState));
    ar.Write(&outputState,sizeof(outputState));

    ar.Write(&wavetype,sizeof(wavetype));
    ar.Write(&analisistype,sizeof(analisistype));
    ar.Write(&regulationtype,sizeof(regulationtype));

    ar.Write(&gridLight,sizeof(gridLight));
    ar.Write(&osdIntensity,sizeof(osdIntensity));
    ar.Write(&traceIntensity,sizeof(traceIntensity));

    ar.Write(&trigtype,sizeof(trigtype));
    ar.Write(&trigpos,sizeof(trigpos));
    ar.Write(&triglev,sizeof(triglev));
    ar.Write(&trigist,sizeof(trigist));
    ar.Write(&trigstab,sizeof(trigstab));
    ar.Write(&trigslope,sizeof(trigslope));
    ar.Write(&trigburst,sizeof(trigburst));

	ar.Write(&delayneg,sizeof(delayneg));
    ar.Write(&vispos,sizeof(vispos));
    ar.Write(&deltapos,sizeof(deltapos));

    ar.Write(&curs1,sizeof(curs1));
    ar.Write(&curs2,sizeof(curs2));
    ar.Write(&responsespeed,sizeof(responsespeed));
    ar.Write(&curstype,sizeof(curstype));
    ar.Write(&timetype,sizeof(timetype));
    ar.Write(&volttype,sizeof(volttype));
    ar.Write(&xlogtype,sizeof(xlogtype));
    ar.Write(&ylogtype,sizeof(ylogtype));

    ar.Write(&bandwidth,sizeof(bandwidth));
    ar.Write(&spectrum3D,sizeof(spectrum3D));
}

void DAA_Load(CArchive& ar)
{
    CString str;
    ar.Read(str.GetBuffer(12), 12); 
    if (str == "DAA_REG 1.1 ")
    {
        int newinputState;
        int newoutputState;

        ar.Read(&freq,sizeof(freq));
        ar.Read(&freqmin,sizeof(freqmin));
        ar.Read(&freqmax,sizeof(freqmax));
        ar.Read(&sweeptime,sizeof(sweeptime));
        ar.Read(&start_sampling_ms,sizeof(start_sampling_ms));
        ar.Read(&sampling_ms,sizeof(sampling_ms));
 
        ar.Read(&duty,sizeof(duty));
        ar.Read(&burstcycles,sizeof(burstcycles));
        ar.Read(&pausecycles,sizeof(pausecycles));
        ar.Read(&dbmin,sizeof(dbmin));
        ar.Read(&dbmax,sizeof(dbmax));
        ar.Read(&outlevel,sizeof(outlevel));
    
        ar.Read(&scaleX,sizeof(scaleX));
        ar.Read(&scaleY1,sizeof(scaleY1));
        ar.Read(&scaleY2,sizeof(scaleY2));
        ar.Read(&regX,sizeof(regX));
        ar.Read(&regY1,sizeof(regY1));
        ar.Read(&regY2,sizeof(regY2));
                                             
        ar.Read(&posY1,sizeof(posY1));
        ar.Read(&posY2,sizeof(posY2));  
              
        ar.Read(&selectCH,sizeof(selectCH));
        ar.Read(&gnd1,sizeof(gnd1));
        ar.Read(&gnd2,sizeof(gnd2));
        ar.Read(&trigCH,sizeof(trigCH));
        ar.Read(&newinputState,sizeof(newinputState));
        ar.Read(&newoutputState,sizeof(newoutputState));

        ar.Read(&wavetype,sizeof(wavetype));
        ar.Read(&analisistype,sizeof(analisistype));
        ar.Read(&regulationtype,sizeof(regulationtype));
    
        ar.Read(&gridLight,sizeof(gridLight));
        ar.Read(&osdIntensity,sizeof(osdIntensity));
        ar.Read(&traceIntensity,sizeof(traceIntensity));
    
        ar.Read(&trigtype,sizeof(trigtype));
        ar.Read(&trigpos,sizeof(trigpos));
        ar.Read(&triglev,sizeof(triglev));
        ar.Read(&trigist,sizeof(trigist));
        ar.Read(&trigstab,sizeof(trigstab));
        ar.Read(&trigslope,sizeof(trigslope));
        ar.Read(&trigburst,sizeof(trigburst));

		ar.Read(&delayneg,sizeof(delayneg));
        ar.Read(&vispos,sizeof(vispos));
        ar.Read(&deltapos,sizeof(deltapos));

        ar.Read(&curs1,sizeof(curs1));
        ar.Read(&curs2,sizeof(curs2));
        ar.Read(&responsespeed,sizeof(responsespeed));
        ar.Read(&curstype,sizeof(curstype));
        ar.Read(&timetype,sizeof(timetype));
        ar.Read(&volttype,sizeof(volttype));
        ar.Read(&xlogtype,sizeof(xlogtype));
        ar.Read(&ylogtype,sizeof(ylogtype));

        ar.Read(&bandwidth,sizeof(bandwidth));
        ar.Read(&spectrum3D,sizeof(spectrum3D));

        DAA_SetBandwidth(bandwidth);
        DAA_SetRegulationType(regulationtype);
        DAA_SetTrigType(trigtype);
        DAA_SetLightedKeys(&MemDC);

        if (analisistype == ANTYPE_SPECTR && spectrum3D && spectrumDisplay) display.Clear();
        display.CreateGrid();
    
        DAA_FillWaveTable(wavetype);

        ResetSweep(TRUE);
        calibratedResponse = FALSE;
        ledcal.Update(&MemDC, 0);
             
        DAA_InputOn(newinputState);
        DAA_OutputOn(newoutputState, TRUE);
        DAA_PressKeys(&MemDC);
    }
    else
    {   
        CFile* fp = ar.GetFile();
        CString str1;
        str1.Format("%s", fp->GetFileName());
        str1 += " is not a valid DAA 1.1 regulations file";
        theApp.m_pMainWnd->MessageBox(str1, "DAA", MB_ICONEXCLAMATION); 
    }
}

void DAA_DrawUpdatedDialers(CDC* pDC)
{
    DAA_SetLightedKeys(pDC);

    dialer.UpdatePosition(pDC);
    dialer1.UpdatePosition(pDC);
    dialer2.UpdatePosition(pDC);
    dialer3.UpdatePosition(pDC);
    dialer4.UpdatePosition(pDC);
    dialer5.UpdatePosition(pDC);
    dialer6.UpdatePosition(pDC);
    dialer7.UpdatePosition(pDC);
    dialer8.UpdatePosition(pDC);
    dialer9.UpdatePosition(pDC);
    dialer10.UpdatePosition(pDC);
    dialer11.UpdatePosition(pDC);
    dialer12.UpdatePosition(pDC);
    dialer13.UpdatePosition(pDC);
}

void DAA_PressKeys(CDC* pDC)
{
    kbInOnOff.PressKey(pDC, inputState);
    kbOutOnOff.PressKey(pDC, outputState);
    kbChan.PressKey(pDC, selectCH);
    kbGnd1.PressKey(pDC, gnd1);
    kbGnd2.PressKey(pDC, gnd2);
    kbChtrig.PressKey(pDC, trigCH);
    kbTrig.PressKey(pDC, trigtype);
    kbAtype.PressKey(pDC, analisistype);
    kbWtype.PressKey(pDC, wavetype);

    kbGnd1.PressKey(pDC, gnd1);
    kbGnd2.PressKey(pDC, gnd2);
    kbCurs.PressKey(pDC, curstype);
    kbTime.PressKey(pDC, timetype);
    kbVolt.PressKey(pDC, volttype);
    kbXlog.PressKey(pDC, xlogtype);   
    kbYlog.PressKey(pDC, ylogtype);

    if (regulationtype < 6)
    {
        kbRtype.PressKey(pDC, regulationtype);
        kbRtype2.PressKey(pDC, -1);
    }
    else
    {
        kbRtype.PressKey(pDC, -1);
        kbRtype2.PressKey(pDC, regulationtype - 6);
    }

    key1.PressKey(pDC, trigslope);
    key2.PressKey(pDC, trigburst);
	key3.PressKey(pDC, delayneg);
}



BOOL DAA_GetMultiDraw()
{
    return multiDraw;
}


BOOL DAA_GetSpectrumDisplay()
{
    return spectrumDisplay;
}

BOOL DAA_GetSpectrum3D()
{
    return spectrum3D;
}

void DAA_Spectrum3D()
{
    spectrum3D = !spectrum3D;
    if (analisistype == ANTYPE_SPECTR && spectrum3D && spectrumDisplay) display.Clear();
    display.CreateGrid();
}

void DAA_SetReference()
{
    if (referenceFlag)
    {
        display.CreateGrid();
        referenceFlag = FALSE;
    }
    else
    {
        if (analisistype != ANTYPE_SPECTR || !spectrum3D || !spectrumDisplay)
        {
            display.dcGrid.BitBlt(0, 0,
                                  dispx + leftborder,
                                  dispy + downborder,
                                  &display.dcScreen,
                                  0, 0, SRCCOPY);
            referenceFlag = TRUE;
        }
    }
}

BOOL DAA_GetReference()
{
    return referenceFlag;
}


void DAA_SetBandwidth(int bw)
{
    bandwidth = bw;
    double b = 1;
    if (bandwidth == 0) b = 1; // max
    /*
    if (bandwidth == 1) b = 1.05946309;  // 1/12
    if (bandwidth == 2) b = 1.12246205;  // 1/6
    */
    if (bandwidth == 1) b = 1.02337389; //  1/30
    if (bandwidth == 2) b = 1.07177346; //  1/10
    if (bandwidth == 3) b = 1.25992105; //  1/3
    if (bandwidth == 4) b = 2;          //  1
    band = float(b);
    if (calibratedResponse)
    {
        CMainFrame *wnd = (CMainFrame *) theApp.m_pMainWnd;
	    CDaaView *viewwnd = (CDaaView *) wnd->GetActiveView ();	    
        CDC* pDC = viewwnd->GetDC();
        ledcal.Update(pDC, 0);
        viewwnd->ReleaseDC(pDC);
        calibratedResponse = FALSE;   
    }
}

int  DAA_GetBandwidth()
{
    return bandwidth;
}


void DAA_ToggleMultiDraw()
{
    if (multiDraw) multiDraw = FALSE;
    else multiDraw = TRUE;
}



CBitmap* DAA_GetDisplayBitmap()
{
	return &display.bmpScreen;
}








///////////////////////////////////////////////////////////////////////////////////////////////
// TIMER      
///////////////////////////////////////////////////////////////////////////////////////////////

//void CALLBACK EXPORT TimerProc (HWND hWnd, UINT nMsg, UINT nIDEvent, DWORD dwTime)
//{   

//}




///////////////////////////////////////////////////////////////////////////////////////////////
// INPUT OUTPUT - ON OFF    
///////////////////////////////////////////////////////////////////////////////////////////////


BOOL DAA_InputOn(int type)
{
    DAA_InputOff();
    if (!type) return TRUE;

     
    //**************************************************
    // Special close and reopen output to avoid problems
    // when opening input while output is open.                                 
    BOOL reOpenOutput = FALSE;
    //if (activeOutBuffers > 0)
    if (outputState)
    {
        DAA_OutputOff();
        reOpenOutput = TRUE;
    }
    //***************************************************
      

    inputState = type;
    numCH = type;
    int result;
    WAVEFORMATEX wfx;
    wfx.wFormatTag = WAVE_FORMAT_PCM;
	wfx.nChannels = WORD(1 * type);
	wfx.nSamplesPerSec = SAMPLES_PER_SEC;
	wfx.nAvgBytesPerSec	= SAMPLES_PER_SEC * 2 * type;
	wfx.nBlockAlign = WORD(2 * type);
	wfx.wBitsPerSample = 16;
	wfx.cbSize = 0;

    result = waveInOpen(
                        &hwIn,
                        WAVE_MAPPER,
                        &wfx, 
                        (DWORD)waveInProc,
                        NULL,
                        CALLBACK_FUNCTION //| WAVE_MAPPED
                        ); 


    if (result != MMSYSERR_NOERROR)
    {
        char c [100];
        waveInGetErrorText(result, c, 99);
        ClipCursor(NULL);
        theApp.m_pMainWnd->MessageBox(c,"WaveInOpen", MB_SYSTEMMODAL);
        inputState = 0;
        return FALSE;
    }
    

	// -------------------------------------- prepare all the headers
	WAVEHDR* pwh;
    __int16* pbuf;
	for (int i = 0; i < N_BUFIN; i++)
    {
		pwh = &pwhIn[i];
		pbuf = pbufIn[i];        
		//
		pwh->lpData = (CHAR*)pbuf;
		pwh->dwBufferLength = IN_BUF_LEN * 2;
		pwh->dwFlags = 0;
		pwh->dwLoops = 0;	
		pwh->lpNext = 0;
		pwh->reserved = 0;
		//
		waveInPrepareHeader(hwIn, pwh, sizeof(WAVEHDR));
	}
	// ------------------------------------------------------------------- 



	// -------------------------------------- add buffers
    readpos = 0;
    vpepInst = 0;
    nbufIn = 0;
    vmax = vmin = 0;

  
    for (int i = 0; i < N_BUFIN; i++) AddBuffer();
    cbufPos = 0;
    
    result = waveInStart(hwIn);
    if (result != MMSYSERR_NOERROR)
    {
        char c [100];
        waveInGetErrorText(result, c, 99);
        ClipCursor(NULL);
        theApp.m_pMainWnd->MessageBox(c,"WaveInStart", MB_SYSTEMMODAL);
        inputState = 0;
        return FALSE;
    } 

    //**************************************************
    // Special close and reopen output to avoid problems
    // when opening input while output is open.
    if (reOpenOutput) DAA_OutputOn(1, FALSE);
    // *************************************************


	// ------------------------------------------------------------------- START TIMER
	//SetTimer(NULL, 1, 100, &TimerProc);


    return TRUE;
}




BOOL DAA_OutputOn(int type, BOOL report_errors)
{   
    DAA_OutputOff();
    if (!type) return TRUE;

    outputState = type;

    int result;
    WAVEFORMATEX wfx;
    wfx.wFormatTag = WAVE_FORMAT_PCM;
	wfx.nChannels = 1;
	wfx.nSamplesPerSec = SAMPLES_PER_SEC;
	wfx.nAvgBytesPerSec	= SAMPLES_PER_SEC * 2;
	wfx.nBlockAlign = 2;
	wfx.wBitsPerSample = 16;
	wfx.cbSize = 0;
     
    result = waveOutOpen(
                         &hwOut,                
		                 WAVE_MAPPER, 
		                 &wfx,
		                 (DWORD)waveOutProc,
		                 NULL,
		                 CALLBACK_FUNCTION | WAVE_ALLOWSYNC //| WAVE_MAPPED
                        );

   
    if (result != MMSYSERR_NOERROR)
    {
        if (report_errors)
        {
            char c [100];
            waveOutGetErrorText(result, c, 99);
            ClipCursor(NULL);
            theApp.m_pMainWnd->MessageBox(c,"WaveOutOpen", MB_SYSTEMMODAL);
        }
        outputState = 0;
        return FALSE;
    }


	// --------------------------------------------- prepare all the headers 
	WAVEHDR* pwh;
	__int16* pbuf;
	//
	for (int i = 0; i < N_BUFOUT; i++)
	{
		pwh = &pwhOut[i];
		pbuf = pbufOut[i];
		//
		pwh->lpData = (CHAR*)pbuf;
		pwh->dwBufferLength = OUT_BUF_LEN * 2;
		pwh->dwFlags = 0;
		pwh->dwLoops = 0;
		pwh->lpNext = 0;
		pwh->reserved = 0;			
	    //
		waveOutPrepareHeader(hwOut, pwh, sizeof(WAVEHDR));
	}
	// -------------------------------------------------------------------


	// --------------------------------------------- 
    oldfreq = freq;
    phase = 0;
    nbufOut = 0;

    waveOutPause(hwOut);
    for (int i = 0; i < N_BUFOUT; i++) FillBuffer(); 



	// ------------------------------------------------- ensure a consistent start timing
	waveInStop(hwIn);
	waveOutPause(hwOut);

	//pulseFlag = false;
	//cbufPos = 0;
	//nbufIn = 0;
	//nbufOut = 0;

	if (inputState > 0)	waveInStart(hwIn);
	if (outputState > 0) waveOutRestart(hwOut);

	// -------------------------------------------------------------------  START TIMER
	//SetTimer(NULL, 1, 100, &TimerProc);

    return TRUE;
}






void DAA_InputOff()
{
	//KillTimer(NULL, 1);

    //if (inputState == 0) return;
    inputState = 0; 

    waveInReset(hwIn);

	// ------------------------------------------- unprepare all the headers 
	for (int i = 0; i < N_BUFIN; i ++)
    {
		waveInUnprepareHeader(hwIn, &pwhIn[i], sizeof(WAVEHDR));
	}

	// ------------------------------------------- close
    waveInClose(hwIn);
}




void DAA_OutputOff()
{
	//KillTimer(NULL, 1);

    //if (outputState == 0) return;
    outputState = 0;       
									
    waveOutReset(hwOut);

	// ------------------------------------------- unprepare all the headers 
	for (int i = 0; i < N_BUFOUT; i ++)
    {
		waveOutUnprepareHeader(hwOut, &pwhOut[i], sizeof(WAVEHDR));
	}

	// ------------------------------------------- close
    waveOutClose(hwOut);
}






/////////////////////////////////////////////////////////////////////////
// ON IDLE
/////////////////////////////////////////////////////////////////////////


void DAA_OnIdle(CDC* pDC)
{
    display.DisplayWave(pDC);   
    ledtrig.Update(pDC, triggered);
	indicator.Update(pDC);
}


BOOL CDaaApp::OnIdle(LONG lCount) 
{ 
	lCount;
	//
    InitTime();

    CMainFrame *wnd = (CMainFrame *) m_pMainWnd;
	CDaaView *viewwnd = (CDaaView *) wnd->GetActiveView ();
    CDC* pDC = viewwnd->GetDC();
	DAA_OnIdle(pDC);
    viewwnd->ReleaseDC(pDC);

    while (GetTime() < 20000) Sleep(5);
	Sleep(1);

    return true;
}







