// DaaView.cpp : implementation of the CDaaView class
//

#include "stdafx.h"
#include "Daa.h"

#include "DaaDoc.h"
#include "DaaView.h"

#include "Daa.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDaaView

IMPLEMENT_DYNCREATE(CDaaView, CView)

BEGIN_MESSAGE_MAP(CDaaView, CView)
	//{{AFX_MSG_MAP(CDaaView)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_KEYDOWN()
	ON_WM_CREATE()
	//
	ON_COMMAND(ID_TEST_SPECTRUM3D, OnTestSpectrum3d)
	ON_UPDATE_COMMAND_UI(ID_TEST_SPECTRUM3D, OnUpdateTestSpectrum3d)
	ON_COMMAND(ID_VIEW_SETREFERENCE, OnViewSetreference)
	ON_UPDATE_COMMAND_UI(ID_VIEW_SETREFERENCE, OnUpdateViewSetreference)
	ON_COMMAND(ID_HELP_HELP, OnHelpHelp)
	ON_UPDATE_COMMAND_UI(ID_TEST_MULTIDRAW, OnUpdateTestMultidraw)
	ON_COMMAND(ID_TEST_MULTIDRAW, OnTestMultidraw)
	//
	ON_COMMAND(ID_BW_MAX, OnBwMax)
	ON_COMMAND(ID_BW_30, OnBw30)
	ON_COMMAND(ID_BW_10, OnBw10)
	ON_COMMAND(ID_BW_3, OnBw3)
	ON_COMMAND(ID_BW_1, OnBw1)
	ON_UPDATE_COMMAND_UI(ID_BW_MAX, OnUpdateBwMax)
	ON_UPDATE_COMMAND_UI(ID_BW_30, OnUpdateBw30)
	ON_UPDATE_COMMAND_UI(ID_BW_10, OnUpdateBw10)
	ON_UPDATE_COMMAND_UI(ID_BW_3, OnUpdateBw3)
	ON_UPDATE_COMMAND_UI(ID_BW_1, OnUpdateBw1)
	//
	ON_COMMAND(ID_OPEN_MIXERS, OnOpenMixers)
	//ON_UPDATE_COMMAND_UI(ID_OPEN_MIXERS, OnBw1)
	ON_COMMAND(ID_AUDIO_DEVICES, OnOpenAudioDevices)
	//ON_UPDATE_COMMAND_UI(ID_AUDIO_DEVICES, OnBw1)
	//
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDaaView construction/destruction

CDaaView::CDaaView()
{
	// TODO: add construction code here

}

CDaaView::~CDaaView()
{
}

BOOL CDaaView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CDaaView drawing

void CDaaView::OnDraw(CDC* pDC)
{
	DAA_Draw(pDC);
}

/////////////////////////////////////////////////////////////////////////////
// CDaaView printing

BOOL CDaaView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CDaaView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CDaaView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CDaaView diagnostics

#ifdef _DEBUG
void CDaaView::AssertValid() const
{
	CView::AssertValid();
}

void CDaaView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CDaaDoc* CDaaView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDaaDoc)));
	return (CDaaDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDaaView message handlers

void CDaaView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CClientDC dc(this);
	DAA_LButtonDown(&dc, point);
	CView::OnLButtonDown(nFlags, point);
}

void CDaaView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	CClientDC dc(this);
	DAA_LButtonUp(&dc, point);	
	CView::OnLButtonUp(nFlags, point);
}

void CDaaView::OnMouseMove(UINT nFlags, CPoint point) 
{
	CClientDC dc(this);
	DAA_MouseMove(&dc, point);
	CView::OnMouseMove(nFlags, point);
}

void CDaaView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	CClientDC dc(this);
    DAA_KeyDown(&dc, nChar);
	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CDaaView::OnTestSpectrum3d() 
{
	DAA_Spectrum3D();
}


void CDaaView::OnViewSetreference() 
{
	DAA_SetReference();
}


void CDaaView::OnUpdateViewSetreference(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetReference());
}



void CDaaView::OnUpdateTestSpectrum3d(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetSpectrum3D());
}



void CDaaView::OnTestMultidraw() 
{
	DAA_ToggleMultiDraw();
}


void CDaaView::OnUpdateTestMultidraw(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetMultiDraw());
}




// BANDWIDTH

void CDaaView::OnBwMax() 
{
	DAA_SetBandwidth(0);
}

void CDaaView::OnBw30() 
{
	DAA_SetBandwidth(1);
}

void CDaaView::OnBw10() 
{
	DAA_SetBandwidth(2);
}

void CDaaView::OnBw3() 
{
	DAA_SetBandwidth(3);
}

void CDaaView::OnBw1() 
{
	DAA_SetBandwidth(4);
}

void CDaaView::OnUpdateBwMax(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetBandwidth() == 0); 
}

void CDaaView::OnUpdateBw30(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetBandwidth() == 1);
}

void CDaaView::OnUpdateBw10(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetBandwidth() == 2);
}

void CDaaView::OnUpdateBw3(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetBandwidth() == 3);
}

void CDaaView::OnUpdateBw1(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetBandwidth() == 4);
}




void CDaaView::OnOpenMixers()
{
	WinExec("sndvol32.exe",	SW_SHOWNORMAL);
	WinExec("sndvol32.exe /rec", SW_SHOWNORMAL);
	WinExec("sndvol.exe",	SW_SHOWNORMAL);
	WinExec("sndvol.exe /rec", SW_SHOWNORMAL);
}

void CDaaView::OnOpenAudioDevices()
{
	// -------------------------------------------------------- GetVersionEx
	OSVERSIONINFO osvi;
    BOOL IsWindowsVista = false;
	//
    ZeroMemory(&osvi, sizeof(OSVERSIONINFO));
    osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
    GetVersionEx(&osvi);
	if (osvi.dwMajorVersion >= 6) IsWindowsVista = true;
	
	if (IsWindowsVista) WinExec("control mmsys.cpl,,1", SW_SHOWNORMAL);
	else WinExec("control mmsys.cpl,,2", SW_SHOWNORMAL);
}


void CDaaView::OnHelpHelp() 
{
	// ---------------------------------------------------------------------------------- get app path and name
	CString strPath;
	TCHAR* pstrExePath = strPath.GetBuffer (MAX_PATH);
	::GetModuleFileName (0, pstrExePath, MAX_PATH);
	strPath.ReleaseBuffer ();
	// ---------------------------------------------------------------------------------- remove "Daa.exe"
	strPath = strPath.Left(strPath.GetLength() - 7);
	// ---------------------------------------------------------------------------------- open Daa.pdf
	ShellExecute(NULL, NULL, strPath + "Daa.pdf", NULL, NULL, SW_SHOW);
}

int CDaaView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;


	SetClassLong (m_hWnd, GCL_HBRBACKGROUND, LONG (HBRUSH (sfondo)));
	                                          
	return 0;
}
