
#ifndef INC_GLOBALS
#define INC_GLOBALS


/////////////////////////////////////////////////////////////////////////
// GLOBALS
/////////////////////////////////////////////////////////////////////////

const int CLIENT_X = 794;
const int CLIENT_Y = 550;  

// display width and height
const int dispdx = 352;
const int dispdy = 264;


	//##############################
//const int N_BUFIN = 16;
//const int IN_BUF_LEN = 512; 
//const int IN_CBUF_LEN = IN_BUF_LEN * 1000;
//
//const int N_BUFOUT = 4; //16
//const int OUT_BUF_LEN = 8192; // 1000  //gravis >= 2 * 4000


const int N_BUFIN = 16;				// >8*1024 on Vista
const int IN_BUF_LEN = 1024; 
const int IN_CBUF_LEN = 1024 * 512 * 2;  // *2 if SAMPLES_PER_SEC = 192000

const int N_BUFOUT = 32;			// >16*1024 on Vista
const int OUT_BUF_LEN = 1024;


// Audio Device - Realtek(computer LAB) - Precision 
//      10%: 4000 6400 6800 7000 99000
//  1/10000: 8000 10000 11025 13600 20400 22050 25000 35000 44100
// 2/100000: 5000 20000
// 1/100000: 6000 9000 12000 12800 15000 18000 21000 24000 27000 30000 33000 45000 90000 96000

// ===============================================
//  Normal sampling: 44100 / 96000 / 192000
// ===============================================
// -------------------------------------------------------------- SAMPLES_PER_SEC = 96000
//const int SAMPLES_PER_SEC = 96000;
//const int MAX_FHT_SAMPLES = 32768;
//const int PULSE_FHT_SAMPLES = 16384;
//const int FASTSWEEP_FHT_SAMPLES = 32768;
// -------------------------------------------------------------- SAMPLES_PER_SEC = 192000
const int SAMPLES_PER_SEC = 192000;
const int MAX_FHT_SAMPLES = 65536;
const int PULSE_FHT_SAMPLES = 16384;
const int FASTSWEEP_FHT_SAMPLES = 65536;

// --------------------------------------------------------------
const int WTAB_LEN = SAMPLES_PER_SEC;  // if WTAB_SHIFT = 14 then SAMPLES_PER_SEC can not go over 131000
const int WTAB_SHIFT = 13;             // if WTAB_SHIFT = 13 then SAMPLES_PER_SEC can not go over 262000

// --------------------------------------------------------------
const int PULSE_TOTAL_SAMPLES = int(SAMPLES_PER_SEC * 0.4);
const int PULSE_SAMPLES = int(SAMPLES_PER_SEC * 0.2); 
const int FASTSWEEP_SAMPLES = int(SAMPLES_PER_SEC * 0.4);
//



static int pulse_position = 0;

const double kdb = 8.685889638; 
const double PI = 3.1415926535;

const WORD PRESSED_NOW = 0x8000;
const int RESP_TAB_LEN = 512;

const int out_pulse_millisec = (PULSE_SAMPLES * 1000) / SAMPLES_PER_SEC ;

                      
// int16 per poter fare operazioni aritmetiche sui campioni
// Input
static __int16 pbufIn[N_BUFIN][IN_BUF_LEN];
static __int16 pCbufIn[IN_CBUF_LEN];
// Output
static __int16 pbufOut[N_BUFOUT][OUT_BUF_LEN];
static __int16 wtab[WTAB_LEN];


static HWAVEOUT hwOut;
static HWAVEIN  hwIn;
static WAVEHDR  pwhOut[N_BUFOUT];
static WAVEHDR  pwhIn[N_BUFIN];

static BOOL calibratedResponse;
static double calibrateTab[RESP_TAB_LEN];
static double responseTab[RESP_TAB_LEN];

static int sweepLimit;
static int sweepPos;
static int sweepSample;
static int sweepFreq14;
static int sweepStatus;
static int random;
static double random2;
static int cbufPos;
static double vispos, deltapos;
static int sweepStartSample;

static BOOL spectrumDisplay;
static BOOL multiDraw;
static BOOL spectrum3D;
static BOOL burstflag;

static int nbufOut, nbufIn;
static int activeOutBuffers = 0;
static int activeInBuffers = 0;

static int numCH;

static int phase, burstcounter;
static int readpos;
static int pulseCbuffPos;

static double trigvoid, trigpos, triglev, trigist, trigstab;
static BOOL trigslope;
static BOOL trigburst;
static int trigsample;
static BOOL triggered;

static BOOL delayneg;


static double vpep, vpepInst;
static int vmax, vmin;

static double oldfreq;

static double gridLight, osdIntensity, traceIntensity;

static double scaleX, scaleY1, scaleY2;
static double regX, regY1, regY2;
static double posY1, posY2;
static int calY1, calY2;

static double curs1, curs2;
static double responsespeed;
static int curstype;
static int timetype, volttype;
static int xlogtype, ylogtype;

static int inputState, outputState;

static int selectCH, trigCH;
static int gnd1, gnd2;


const int WAVETYPE_SINE   = 0; 
const int WAVETYPE_TRIANG = 1; 
const int WAVETYPE_RAMPp  = 2; 
const int WAVETYPE_RAMPm  = 3; 
const int WAVETYPE_SQUARE = 4; 
const int WAVETYPE_NOISE  = 5;
//
const int ANTYPE_WAVE     = 0; 
const int ANTYPE_BURST    = 1; 
const int ANTYPE_SPECTR   = 2; 
const int ANTYPE_SWEEP    = 3; 
const int ANTYPE_FASTSW   = 4; 
const int ANTYPE_PULSE    = 5; 
//
static int wavetype;
static int analisistype;
static int regulationtype;
static int trigtype;

static double freq;
static double freqmin;
static double freqmax;
static double sweeptime;
static double start_sampling_ms;
static double sampling_ms;

static double duty;
static double burstcycles;
static double pausecycles;
static double dbmin;
static double dbmax;
static double outlevel;

static int    bandwidth;
static float  band;

static COLORREF black, panels, wavepanel, col_pressed, col_lighted_border; 
static COLORREF grey0, grey1, grey2, grey3, grey4, grey5, grey6, grey7, grey8, grey9, white;
static COLORREF dgrid, dback, trace;


static int fmeterTrigDown = 0;
static int fmeterTrigUp = 0;
static BOOL fmeterFlag = FALSE;                                                                
static int fmeterSamples = 0;             
static int fmeterCycles = 0;    
static int fmeterResultSamples = 0;
static int fmeterResultCycles = 0; 


// values for sweep and spectrum display                                      
static int leftborder = 25;
static int downborder = 16;
static int dispx = dispdx - leftborder;
static int dispy = dispdy - downborder;


// FHT
const int samplesMax = MAX_FHT_SAMPLES;
static float senTab[samplesMax];
static float cosTab[samplesMax];
static float aTab[samplesMax + 1];
static float bTab[samplesMax + 1];
static float hTab[samplesMax];
static int permTab[samplesMax];
static int initSamples = 0;
static int fht_samples = 0;


static BOOL pulseFlag = FALSE;
static BOOL referenceFlag = FALSE;





#endif